/**
 * Created by Sa on 2016-09-25.
 */
/*初始化登录信息*/
//$(function () {

var userInfo = {}
    ,_setInterval = '';

define(function(require, exports, module) {
    /*登录*/
    $(document).on('click', '.login-in-btn', function () {
        /*页面标识*/
        var phone = '',
            code = ''
            ,ele = $(this).parents('.page-current')
            ,tel = ele.find('.input-tel').val()
            ,pwd = ele.find('.input-password').val();
        userInfo.account = tel;
        userInfo.password = pwd;
        //if (!validateData(ele)) return;
        goLogin(userInfo);
    });

    /*查看密码*/
    $(document).on('click', '.look-password-icon', function (e) {
        var toggleEle = $(e.currentTarget).prev('.input-password')
            , key = toggleEle.attr('type') == 'password' ? 'text' : 'password';
        console.log(e.currentTarget, key);
        $(e.currentTarget).prev('input').attr('type', key);
    });

    /*忘记密码*/
    $(document).on('click', '.reset-password', function () {
        /*手机号验证,验证码*/
        console.log('msg validate!');
        $.router.load('#message-validate-page');
       $("#message-validate-page .input-tel").val("");
        $("#message-validate-page .input-code").val("");
    });
    // $(document).on('click','.read-me',function(e){
    //     var checkbox = $(e.currentTarget).find('.checkbox-check')
    //         ,bottomBtn = checkbox.parents('.content').find('span.btn-bottom');
    //     checkbox.toggleClass('checkbox-checked');
    //     /*如果选中了协议项，该页面的'下一步'功能类将被激活*/
    //     if(bottomBtn.length>0){
    //         bottomBtn.toggleClass('next-btn');
    //     }
    // });

    /*短信验证 PS: 此处与用户注册 注册按键重复监听 加not过滤 */
    $(document).on('click', '.validateMsg', function (e) {
        console.log('获取短信验证码');
        /*页面标识*/
        var ele = $(this).parents('.page-current');
        /*h5验证手机号是否合格，否则不提交服务器校验验证码*/
        if (!validateTel(ele)) return;
        /*跳转，密码重置*/
            phone = $("#message-validate-page .input-tel").val();
            code = $("#message-validate-page .input-code").val();
        if(code == '' || code == null || code == undefined){
            $.alert("验证码不能为空！");
            return
        }
        jomooAjax({
            "apiLast": 'validate/validateCode',
            "params": {"code":code},
            "success": function (data) {
                if(data.status){
                    /*清楚定时器*/
                    window.clearInterval(_setInterval);
                    /*重置样式*/
                    $('.validate-ing-code').addClass('validate-code')
                        .text('获取验证码').removeClass('validate-ing-code');
                    $.router.load('#reset-page');
                } else {
                    $.toast(data.errorMessage);
                }
            }
        });
    });

    /*新用户注册*/
    $(document).on('click', '.sp-register.next-btn', function(e){

        /*手机号验证，密码验证，验证码*/
        var page = $(e.currentTarget).parents('.page-current');

        /*开始注册*/
        if (validateData(page)) {
            jomooAjax({
                apiLast: 'member/register',
                params: {
                    userName: userInfo.account,
                    password: userInfo.password,
                    code: userInfo.code
                },
                success: function (data) {
                    if (!data)return;
                    $.alert(data.detail,function(){
                        if(data.status) {
                            $.router.back();
                        }
                    })
                }
            })
        }
    });

    /*验证码*/
    $(document).on('click', '.validate-code', function (e) {
        console.log($(e.currentTarget).parents('.content').find('input[type="tel"]').val());
        /*获取手机号*/
        var telEle = $(e.currentTarget).parents('.content')
            ,type_val = 1
            ,type_num = $(this).attr("id")
            , tel = telEle.find('input[type="tel"]').val();
        if (!validateTel_new(telEle))return;
        var validateBtn = $(e.currentTarget)
            , times = 60;
        if(type_num  == "selectCode"){
            type_val = 1;
        } else {
            type_val = 2
        }

        /*切换样式，展示*/
        validateBtn.addClass("validate-ing-code")
            .text(times + 's后重新获取').removeClass('validate-code');
        /*开始倒计时*/
        _setInterval = setInterval(function () {
            times--;
            $('.validate-ing-code').text(times + 's后重新获取');
            /*倒计时结束*/
            if (times == 0) {
                /*清楚定时器*/
                window.clearInterval(_setInterval);
                /*重置样式*/
                $('.validate-ing-code').addClass('validate-code')
                    .text('获取验证码').removeClass('validate-ing-code');
            }
            console.log(times + 's');
        }, 1000);

        /*获取短信验证码*/
        jomooAjax({
            apiLast: 'regist/getValidateCode',
            params: {phone: tel, type: type_val},
            success: function (data) {
                if(data.status){
                    if(data.detail.status){

                    } else {
                        $.alert(data.detail.msg);
                    }

                } else {
                    $.alert(data.errorMessage);
                }
            }
        })
    });

    /*重置密码-完成*/
    $(document).on('click', '.resetFinish', function () {
        /*页面标识*/
        var ele = $(this).parents('.page-current');
        console.log(ele);
        /*密码校验*/
        if (!validatePassword(ele)) return;
        var password_val =$("#reset-page .input-password").val();
        /*修改密码*/
        jomooAjax({
            apiLast:'member/resetPassword',
            params:{
                phone:phone,
                password:password_val,
                code:code
            },
            success:function(data){
                if(data.status){
                    $.alert("修改成功！",'',function(){
                        history.go(-2);
                    });
                }

            }
        });
    });

    // 注册页面 返回的时候清空数据
    $(document).on('pageAnimationStart', '#register-page', function(e, id, page){
        $('#register-page input').val('');
    });

    // 手机端 输入时候 底部公司信息 遮盖输入框
    $(window).on('resize', function(e){
        $('p.company').toggleClass('hide');
    })

    /*初始化页面*/
    $.init();
});

/*账号信息验证*/
var validateData = function (ele) {
    var flag = false
        , telEle = ele.find('input[class="input-tel"]')
        , passwordEle = ele.find('input[class="input-password"]')
        , codeEle = ele.find('input[class="input-code"]');

    /*登录信息验证*/
    if ((telEle.length == 0 || validateTel_new(ele))
        && (passwordEle.length == 0 || validatePassword(ele))
        && (codeEle.length == 0 || validateCod(ele))) {
        flag = true;
    }
    return flag;
};


/*验证手机号*/
var validateTel = function (ele) {
    var tel = ele.find('input[class="input-tel"]').val()
        , flag = false;
    
    if(!tel || !tel.trim()) {
        $.toast('账号不能为空');
        return;
    }

    userInfo.account = tel;
    flag = true;

    return flag;
};
var validateTel_new = function (ele) {
    var tel = ele.find('input[class="input-tel"]').val()
        , flag = false;

    if(!tel || !tel.trim()) {
        $.toast('手机号码不能为空');
        return;
    }
    //验证手机号
    var myreg = /^[1][3578][0-9]{9}$/;
    //$.trim(phone) != '' &&
    if (!myreg.test(tel.trim())) {
        $.toast('手机号码不正确');
        return;
    }
    userInfo.account = tel;
    flag = true;

    return flag;
};
/*验证密码*/
var validatePassword = function (ele) {
    var passwordEleArr = ele.find('input[class="input-password"]')
        , password = passwordEleArr[0].value
        , flag = false;

    if (password == 0) {
        $.toast("密码不能为空！");
    } else if (password.length < 6) {
        $.toast("密码长度不少于6位！");
    } else if (password.length > 22) {
        $.toast("密码长度不多于22位！");
    } else if (!password.match(/^(?=.*[a-zA-Z])(?=.*[0-9])[a-zA-Z0-9]{6,22}$/)) {
        $.toast("密码为字母和数字的组合！");
    } else if (passwordEleArr.length == 2) {
        var comparePw = passwordEleArr[1].value;
        if (comparePw != password) {
            $.toast("两次密码不一致！");
        } else {
            flag = true;
        }
    } else {
        flag = true;
    }
    if (flag) {
        userInfo.password = password;
    } else {
        userInfo.password = '';
    }
    return flag;
};
/*验证验证码是否符合要求*/
var validateCod = function (ele) {
    var codeEle = ele.find('input[class="input-code"]')
        , code = codeEle.val()
        , flag = false;
    if (code.length == 0) {
        $.toast('验证码不能为空');
    } else if (!code.match(/^\d{6}/)) {
        $.toast('验证码不正确！');
    } else {
        userInfo.code = code;
        flag = true;
    }
    return flag;
};

//});
