﻿define(function (require,exports,module) {
   // $.title = '问卷调查';
    $("title").html("资讯列表");
    var newsType = '' 
    , p_l = 0//当前第几页 列表
    , s_l = 5//每页显示多少条 列表
    , p_c = 0//当前第几页 评论
    , s_c = 5//每页显示多少条 评论
        ,total_num = 3  //总数
    ,data_id // 详情id
    ,zanStatus // YES 可点 ， NO 不可点赞
    ,replayToId = ''
    ;

    $(document).on("pageInit", ".page", function (e, id, page) {
        if (id == 'page-news-list' && !app.isPageBack(id)) {
            console.time('新闻资讯:');
            getTypeHtml();
        }
    });

    /*tab点击事件*/
    $(document).on("click", ".news-tab a", function () {
        //加载当前类型的数据
        p_l = 0;
        newsType = $(this).attr("key");
        getListHtml();

        //选中显示
        $(".news-tab a").removeClass("active");
        $(this).addClass("active");
    });

    /*列表li点击事件*/
    $(document).on("click", ".item-link", function (e) {
        data_id=$(this).attr("data-id");
        exports.getDetailHtml(data_id);
        $.router.load('#page-news-detail');

    });
    //列表分页
    $(document).on("click", "#addMoreList", function (e) {
        p_l++;//页数+1
        addMoreList();

    });
    //评论分页
    $(document).on("click", "#addMoreCommentList", function (e) {
        p_c++;//页数+1
        addMoreCommentList();

    });
    /*获取类型*/
    var getTypeHtml = function () {
        jomooAjax({
            "apiLast":'newestInfo/typeList',
            "params":{p:0,s:10},
            "type": 'get',
            "success":function(data){
                if(!data || !data.status) return;
                var _typeHtml = '',_tabHtml='';
                data = data.typeList;
                for(var i=0;i<data.length;i++){
                    var isFirst = false;
                    if(newsType == ''){
                        if (i == 0) {
                            isFirst = true;
                            newsType = data[i].key;
                        }
                    }
                    _typeHtml += '<a id="tab' + data[i].key + '" key="'+data[i].key+'"  class="tab-link ' + (isFirst ? 'active' : '') + ' button">'
                    + (isFirst ? '' : '<i></i>') + data[i].value + '</a>';
                };
                $(".news-tab").html(_typeHtml);
                $(".tab-link").removeClass("active");
                $("#tab"+newsType).addClass("active");

                getListHtml();
            }
        });
    }

    /*获取列表*/
    var getListHtml = function () {
        data_id='';
        var _type = newsType//咨询类型
        , _listHtml = '';
        p_l = 0;
        /*请求示例*/
        jomooAjax({
            "apiLast":'newestInfo/list',
            "params":{type:newsType,p:p_l,s:s_l},
            "success":function(data){
                if(!data || !data.status) return;
                data = data.list;
                if(data.length>0){
                    _listHtml += '<div id="tab' + _type + '" class="tab  active infinite-scroll">';
                    _listHtml += '<div class="content-block">';

                    // for(var i=0;i<data.length;i++) {
                    //     _listHtml += '<li class="item-content item-link" data-id="' + data[i].id + '">';
                    //     _listHtml += '<div class="data-img"><img onerror="javascript:this.src=\'../public/images/moren1.png\';" src="' + getImgUrl(data[i].coverImg) + '"></div>';
                    //     _listHtml += '<div class="data-title">';
                    //     _listHtml += '<p>' + data[i].title + '</p>';
                    //     _listHtml += '<p><span sytle="color: #717071;">' + helper.timeConverter(data[i].date) + '</span></p>';
                        
                    //     //底部
                    //     _listHtml += '<div class="data-bottom">';
                    //     _listHtml += '<div><span class="icon reads-icon"><labe>' + data[i].viewNum + '</labe></span></div>';
                    //     _listHtml += '<div><span class="icon comments-icon"><labe>' + data[i].commentNum + '</labe></span></div>';
                    //     _listHtml += '<div><span class="icon favorite-icon"><labe>' + data[i].zanNum + '</labe></span></div>';
                    //     _listHtml += '</div>';

                    //     _listHtml += '</div>';
                    //     _listHtml += '</li>';
                    // }
                    _listHtml += createHtmlList(data);
                    _listHtml += '</div>';
                    _listHtml += '</div>';
                    if(data.length == s_l){
                        _listHtml += ' <div class="load-more" id="addMoreList"><span>查看更多</span></div>';
                    }
                    $(".tabs").html(_listHtml);
                } else {
                    if(p_l == 0){
                        baseInfo.nodata(".tabs");
                    }
                }
                console.timeEnd('新闻资讯:');
            }
        });
    }

    function createHtmlList(data){
        var html = '';

        for(var i=0;i<data.length;i++){
            html += '<ul class="c-content item-link" data-id="'+data[i].id+'">';
            html += '<li class="li-first"><img onerror="javascript:this.src=\'../public/images/moren1.png\';" class="li-img" src="'+getImgUrl(data[i].coverImg)+'" alt=""/></li>';
            html += '<li class="li-title ellipsis">'+data[i].title+'</li>';
            html += '<li class="li-description">' + data[i].source + '</li>'
            html += '<li class="li-author"><span>' + data[i].date.substr(0,10) + '</span></li>'
            html += '<li class="li-last"><span class="icon cc-icon reads-icon">' +
                    helper.nc(data[i].viewNum) +
                    '</span><span class="icon cc-icon comments-icon">' + 
                    data[i].commentNum  +
                    '</span><span class="icon cc-icon favorite-icon">' + 
                    helper.nc(data[i].zanNum) +
                    '</span></li>'

            html += '</ul>';
        }
        return html;
    }

    var addMoreList = function () {
        $(".load-more").remove();
        data_id='';
        var _type = newsType//咨询类型
            , _listHtml = '';
        /*请求示例*/
        jomooAjax({
            "apiLast":'newestInfo/list',
            "params":{type:newsType,p:p_l,s:s_l},
            "success":function(data){
                if(!data || !data.status) return;
                data = data.list;
                if(data.length>0){

                    // for(var i=0;i<data.length;i++) {
                    //     _listHtml += '<li class="item-content item-link" data-id="' + data[i].id + '">';
                    //     _listHtml += '<div class="data-img"><img onerror="javascript:this.src=\'../public/images/moren1.png\';" src="' + getImgUrl(data[i].coverImg) + '"></div>';
                    //     _listHtml += '<div class="data-title">';
                    //     _listHtml += '<p>' + data[i].title + '</p>';
                    //     _listHtml += '<p><span sytle="color: #717071;">' + helper.timeConverter(data[i].date) + '</span></p>';
                    //     //底部
                    //     _listHtml += '<div class="data-bottom">';
                    //     _listHtml += '<div><span class="icon reads-icon"><labe>' + data[i].viewNum + '</labe></span></div>';
                    //     _listHtml += '<div><span class="icon comments-icon"><labe>' + data[i].commentNum + '</labe></span></div>';
                    //     _listHtml += '<div><span class="icon favorite-icon"><labe>' + data[i].zanNum + '</labe></span></div>';
                    //     _listHtml += '</div>';
                        
                    //     _listHtml += '</div>';
                    //     _listHtml += '</li>';
                    // }
                    _listHtml += createHtmlList(data);

                    if(data.length == s_l){
                        _listHtml += ' <div class="load-more"><span>查看更多</span></div>';
                    }
                    $(".tabs .content-block").append(_listHtml);
                }

            }
        });
    }

    /*评论加载更多*/
    var addMoreComment = function () {
        p_c = 0;
        jomooAjax({
            "apiLast": 'newestInfo/getCommentList',
            "params": {id: data_id,p:p_c,s:s_c},
            "success": function (data) {
                if (data.status) {
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;

                        for(var i=0;i<data.length;i++) {
                            var hf_pl= '';
                            /*if(data[i].replyTo){
                                hf_pl ='<p class="comment-replyTo"><label>'+data[i].replyTo.userName+'：</label><span style="margin-left: 10px">'+data[i].replyTo.content+'</span></p>';
                            }
                            _html += '<li>';
                            //头像
                            _html += '<div class="comment-userImg"><img onerror="javascript:this.src=\'../public/images/moren2.png\';" src="'+getImgUrl(data[i].headImg)+'"></div>';
                            //用户名
                            _html += '<div class="comment-userName">';
                            _html += '<span class="userName_span" userId="'+data[i].id+'" style="margin-right:5px">' + data[i].userName + '</span>';
                            _html += '<span>' + data[i].level + '</span>';
                            _html += '<span class="gray">' + data[i].commentDate + '</span>';
                            _html += '</div>'+hf_pl;
                            //内容

                            _html += '<div class="comment-text">' + data[i].content + '</div>';
                            _html += '</li>';*/
                            if(data[i].replyTo){
                                hf_pl='<div class="comment-reply-to">' +
                                '<p class="rely-to-info">' +
                                '<span class="reply-commenter-name">'+data[i].replyTo.userName+'</span>' +
                                '<span class="reply-comment-date">'+helper.timeConverter(data[i].replyTo.commentDate)+'</span>' +
                                '</p>' +
                                '<p class="reply-to-content">'+data[i].replyTo.content+'</p>' +
                                '</div>' ;
                                }
                            _html += '<li class="clearfix" data-id="23">' +
                            '<div class="block-left">' +
                            '<img class="head-img" oonerror="javascript:this.src=\'../public/images/moren2.png\';" src="' + getImgUrl(data[i].headImg) + '">' +
                            '</div>' +
                            '<div class="block-right">' +
                            '<div class="clearfix comment-info">' +
                            '<div class="block-left">' +
                            '<span class="commenter-name" userId="'+data[i].id+'">' + data[i].userName + '</span>' +
                            '<span class="comment-date">' + helper.timeConverter(data[i].commentDate) + '</span>' +
                            '</div>' +
                            '<a class="comments-icon ft-right open-comment-reply" userId="'+data[i].id+'"></a>' +
                            '</div>' +
                            '<p class="comment-content">' + data[i].content + '</p>' +hf_pl+

                            '</div>' +
                            '</li>';
                        };
                        if(data.length == s_c){
                            _html += ' <div class="load-more" id="addMoreCommentList"><span>查看更多</span></div>';
                        }
                        $(".commentLi").html(_html);
                        $.closeModal('.popup-comment');
                        $(".popup-overlay").removeClass('modal-overlay-visible');

                        $(".open-comment-reply").click(function () {
                            replayToId = $(this).attr("userId");
                            var popupHTML = '<div class="popup popup-comment">' +
                                '<div class="content-block">' +
                                '<ul><li><a class="close-popup">取消</a></li><li>评论</li><li><a id="sendMess" class="gray">发送</a></li></ul>' +
                                '<textarea id="txtarea-comment" placeholder="请输入评论内容"></textarea >' +
                                '</div>' +
                                '</div>'
                           // $.popup(popupHTML);
                            var _html = '<div class="popup popup-comment" data-popup="open-comment">' +
                                '<div class="content-block">' +
                                '<div class="comment-container">' +
                                '<textarea rows="3" id="txtarea-comment" placeholder="请输入评论内容"></textarea>' +
                                '<p>' +
                                '<a class="ft-right comment-submit" id="sendMess">发表</a>' +
                                '</p>' +
                                '</div>' +
                                '</div>' +
                                '</div>' +
                                '<div class="popup-overlay"></div>';
                            $.popup(_html);
                        });
                    }else {
                        if(p_c == 0){
                            baseInfo.nodata(".commentLi");
                        }

                    }
                }
            }
        });

    }
    var addMoreCommentList = function () {
        $(".load-more").remove();
        jomooAjax({
            "apiLast": 'newestInfo/getCommentList',
            "params": {id: data_id,p:p_c,s:s_c},
            "success": function (data) {
                if (data.status) {
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;

                        for(var i=0;i<data.length;i++) {
                            var hf_pl= '';
                            if(data[i].replyTo){
                                hf_pl='<div class="comment-reply-to">' +
                                '<p class="rely-to-info">' +
                                '<span class="reply-commenter-name">'+data[i].replyTo.userName+'</span>' +
                                '<span class="reply-comment-date">'+helper.timeConverter(data[i].replyTo.commentDate)+'</span>' +
                                '</p>' +
                                '<p class="reply-to-content">'+data[i].replyTo.content+'</p>' +
                                '</div>' ;
                            }
                            _html += '<li class="clearfix" data-id="23">' +
                            '<div class="block-left">' +
                            '<img class="head-img" oonerror="javascript:this.src=\'../public/images/moren2.png\';" src="' + getImgUrl(data[i].headImg) + '">' +
                            '</div>' +
                            '<div class="block-right">' +
                            '<div class="clearfix comment-info">' +
                            '<div class="block-left">' +
                            '<span class="commenter-name" userId="'+data[i].id+'">' + data[i].userName + '</span>' +
                            '<span class="comment-date">' + helper.timeConverter(data[i].commentDate) + '</span>' +
                            '</div>' +
                            '<a class="comments-icon ft-right open-comment-reply" userId="'+data[i].id+'"></a>' +
                            '</div>' +
                            '<p class="comment-content">' + data[i].content + '</p>' +hf_pl+

                            '</div>' +
                            '</li>';
                        };
                        if(data.length == s_c){
                            _html += ' <div class="load-more" id="addMoreCommentList"><span>查看更多</span></div>';
                        }
                        $(".commentLi").append(_html);
                        $.closeModal('.popup-comment');
                        $(".popup-overlay").removeClass('modal-overlay-visible');

                        $(".open-comment-reply").click(function () {
                            replayToId = $(this).attr("userId");
                            var popupHTML = '<div class="popup popup-comment">' +
                                '<div class="content-block">' +
                                '<ul><li><a class="close-popup">取消</a></li><li>评论</li><li><a id="sendMess" class="gray">发送</a></li></ul>' +
                                '<textarea id="txtarea-comment" placeholder="请输入评论内容"></textarea >' +
                                '</div>' +
                                '</div>'
                            //$.popup(popupHTML);
                            var _html = '<div class="popup popup-comment" data-popup="open-comment">' +
                                '<div class="content-block">' +
                                '<div class="comment-container">' +
                                '<textarea rows="3" id="txtarea-comment" placeholder="请输入评论内容"></textarea>' +
                                '<p>' +
                                '<a class="ft-right comment-submit" id="sendMess">发表</a>' +
                                '</p>' +
                                '</div>' +
                                '</div>' +
                                '</div>' +
                                '<div class="popup-overlay"></div>';
                            $.popup(_html);
                        });
                    }
                }
            }
        });
    }


    /*获取详情*/
    exports.getDetailHtml = function (id) {
        data_id = id;
        jomooAjax({
            "apiLast": 'newestInfo/viewDetail',
            "params": {"id":id},
            "success": function (data) {
                //自动计算浏览数
                var num_ = $('.item-content[data-id="'+id+'"]').find('.reads-icon').children().text();
                $('.item-content[data-id="'+id+'"]').find('.reads-icon').children().text(parseInt(num_)+1);

                var _html = '';
                _html += '<p class="detail-title">' + data.list.title + '</p>';
                _html += '<p class="detail-source">';
                _html += '<span>' + data.list.source + '</span>';
                _html += '&nbsp;&nbsp;<span>' + data.list.date + '</span>';
               /* _html += '&nbsp;&nbsp;<span class="icon reads-icon"><labe>' + data.list.lookNum + '</labe></span>';
                _html += '<span class="icon comments-icon"><labe>' + data.list.commentNum + '</labe></span>'
                */_html += '</p>';
                _html += '<div class="detail-text">' + helper.addImageServerUrl(data.list.content) + '</div>';
                $(".detail-content").html(_html);

                var _html = '<div class="allComment">最新评论</div>';
                _html += '<div class="commentLi">';
                _html += '</div>';
                zanStatus = data.list.zanStatus;
                $(".favorite-icon").attr("zan-status",zanStatus);
                $(".detail-comment").html(_html);
                addMoreComment();
            }
        });
    }

    /*点击遮罩层关闭评论modal*/
    $(document).on("click", ".popup-overlay", function () {
        $(this).removeClass('modal-overlay-visible')
        $.closeModal('.popup-comment');
    });

    /*详情底部点击事件*/
    $(document).on("click", "#db_bottom a", function () {
        if(isLogin()) {
            var id = $(this).attr("id");
            if (id == 'commentsBtn') {//评论
                replayToId = '';
                /*var popupHTML = '<div class="popup popup-comment">' +
                    '<div class="content-block">' +
                    '<ul><li><a class="close-popup">取消</a></li><li>评论</li><li><a id="sendMess" class="gray">发送</a></li></ul>' +
                    '<textarea id="txtarea-comment" placeholder="请输入评论内容"></textarea >' +
                    '</div>' +
                    '</div>'
                $.popup(popupHTML);*/
                var _html = '<div class="popup popup-comment" data-popup="open-comment">' +
                    '<div class="content-block">' +
                    '<div class="comment-container">' +
                    '<textarea rows="3" id="txtarea-comment" placeholder="请输入评论内容"></textarea>' +
                    '<p>' +
                    '<a class="ft-right comment-submit" id="sendMess">发表</a>' +
                    '</p>' +
                    '</div>' +
                    '</div>' +
                    '</div>' +
                    '<div class="popup-overlay"></div>';
                $.popup(_html);
                //$("#txtarea-comment").focus();//加了聚焦之后页面会闪一下
            } else if (id == 'favoriteBtn') { // 点赞
                if (zanStatus == "YES") {
                    jomooAjax({
                        "apiLast": 'newestInfo/addZan',
                        "params": {"id": data_id},
                        "success": function (data) {
                            if (data.status) {
                                $.toast('点赞成功！');
                                zanStatus = "NO";
                                $(".favorite-icon").attr("zan-status",zanStatus);
                                //自动计算点赞数
                                var num_ = $('.item-content[data-id="'+data_id+'"]').find('.favorite-icon').children().text();
                                $('.item-content[data-id="'+data_id+'"]').find('.favorite-icon').children().text(parseInt(num_)+1);

                            } else {
                                $.toast('点赞失败！');
                            }
                        }
                    });
                } else {
                    $.toast('已经点赞过了！');
                    return;
                }
            } else if (id == 'shareBtn') { //分享

            }
        }
    });

    /*textarea输入监控*/
    $(document).on("input", "#txtarea-comment", function () {
        if ($.trim($(this).val())) {
            $("#sendMess").addClass('gray')
        } else {
            $("#sendMess").removeClass('gray')
        }
    });

    /*点击发送*/
    $(document).on("click", "#sendMess", function () {
        var sendComment = $("#txtarea-comment").val();
        if(sendComment){
            jomooAjax({
                "apiLast": 'newestInfo/addComment',
                "params": {"id":data_id,"replayToId":replayToId,"content":sendComment},
                "success": function (data) {
                    if(data.status){
                        $.toast("评论成功!");
                        addMoreComment();
                        //自动计算评论数
                        var num_ = $('.item-content[data-id="'+data_id+'"]').find('.comments-icon').children().text();
                        $('.item-content[data-id="'+data_id+'"]').find('.comments-icon').children().text(parseInt(num_)+1);
                    } else {
                        $.toast('评论失败！');
                    }
                }
            });
        }else {
            $.toast('评论内容不能为空！');
        }
    });

});