/**
 * Created by Sa on 2016-10-31.
 */

/*
 * 测试环境地址：http://demo.coracle.com/JMAPP/api/v1/common/upload-file
 * */
 var uploader = function(param){
     /*
     * ele = {
     *  bindEle:id/class/$  //触发事件的元素
     *  imgBox:id/class/$   //上传成功后，要显示图片的容器
     * }
     *
     * */
    var $ = jQuery
        ,pick = param.ele;
    /*初始化Web Uploader*/
    var uploader = new WebUploader.Uploader({
        //选择完文件后自动上传
        auto:true,
        //swf文件路径
        swf:'http://cdn.staticfile.org/webuploader/0.1.0/Uploader.swf',
        //文件接受服务器
        server:'http://demo.coracle.com/JMAPP/api/v1/common/upload-file',
//        server:'http://172.18.91.136/JMAPP/api/v1/common/upload-file',
        //选择文件的按钮，可选
        //内部根据当前运行创建，可能是input元素，也可能是flash
        pick:pick,
        //不压缩image，默认如果是jpeg，文件上传前会压缩一把再上传
        resize:true,

        /*配置压缩的图片选项*/
        compress:{
            width:414,
            height:736,
            allowMagnify:false,
            //图片质量
            quality:2000,
            // 单位字节，如果图片大小小于此值，不会采用压缩。
            compressSize: 1024*200
        },

        //只允许选择图片文件
        accept:{
            title:'Images',
            extensions:'gif,jpg,jpeg,png',
            mimeTypes:'image/*'
        },
        fileNumLimit:6
    });
    /*当有文件被添加进队列的时候*/
    uploader.on('fileQueued',function(file){
        ///*图片上传后添加的对象*/
        //var $item = $(
        //        '<div id="' + file.id + '" class="file-item thumbnail">' +
        //        '<img>' +
        //        '<div class="info">' + file.name + '</div>' +
        //        '</div>'
        //    )
        //    ,$img = $item.find('img');
        //$('.process').append($item);
        //
        ////创建缩略图
        ////如果为非图片文件，可以不用调用该方法
        ////thumbnailWidth x thumbnailHeight,100 x 100
        //var thumbnailWidth = 100
        //    ,thumbnailHeight = 100;
        //uploader.makeThumb(file,function(error,src){
        //    if(error){
        //        $img.replaceWith('<span>无法预览该图片！</span>');
        //        return;
        //    }
        //    $img.attr('src',src);
        //},thumbnailWidth,thumbnailHeight);
    });

    uploader.on('uploadBeforeSend',function(object,data,headers){
        console.log('upload before send:',object,data,headers);
//        uploader.formData = object;
    });
    uploader.on('error',function(string){
        console.log('upload error:',string);
        if(string == 'F_DUPLICATE'){
            //上传了重复的图片会触发
            alert('请不要重复上传!');
        }
    });
     /*上传中触发*/
     uploader.on('uploadProgress',function(file,percentage){
            $('.process').css('width',percentage*100+'%');
         var processHtml = '<div class="process-view"><span>'+percentage*100+'%</span></div>';
         if($('.process-view').length<1){
            $('body').append(processHtml)
         }
     });
    /*上传完成后的处理*/
    uploader.on('uploadComplete',function(file){
        console.log('upload complete:',file);
        $('.process-view').remove();
    });
    /*上传成功后的处理*/
    uploader.on('uploadSuccess',function(file,respone){
        console.log('upload Success:',respone,file,JSON.parse(respone._raw));
        var imgUrl = respone.imgUrl;
        if(typeof param.uploadSuccess == "function"){
            param.uploadSuccess(imgUrl);
        }
    });
     /*上传错误后的处理*/
     uploader.on('uploadError',function(file,reason){
         if(typeof param.uploadError == 'function'){
             param.uploadError(file,reason);
         }
     });
};