﻿define(function (require,exports,module) {
    // $("title").html("问卷调查");
    var p = 0//当前第几页
            , s = 5//每页显示多少条
        ,data_length = 0
        ,list_id = ''
        ,answer = false//是否答题 false-答 true结果
        ,end_time = ''

    ;
    $(document).on("pageInit", ".page", function (e, id, page) {
        if (id == 'page-queSurvey-list' && !app.isPageBack(id)) {
            p = 0;
            //获取第一页列表
           addMoreList();
        }

    });
    //题目列表
    $(document).on("click", "#questionList", function (e) {

        $.router.load('#page-queSurvey-detail', $(e.currentTarget).data('id'), true);
        var id = $(this).attr("data-code");
        answer = $(this).attr("data-answer");
        list_id = id;
        exports.getDetailHtml(id);
    });
    //列表分页
    $(document).on("click", "#addMoreList", function (e) {
        p++;//页数+1
        add_MoreList();
    });
    //搜索
    $(document).on("click", ".searchbar .a-search", function (e) {
        p=0
        addMoreList();
    });
    //提交
    $(document).on("click", "#submit", function (e) {
        var submitData = {}
            ,answerList = []
            ,optionItem = 0;
        var new_date = new Date();
        //var new_time = new_date.getFullYear();
        var new_year = parseInt(new_date.getFullYear())+'-'+parseInt(new_date.getMonth()+1)+'-'+parseInt(new_date.getDate());


        /*获取单选*/
        $("ul.ul-raido").each(function(){
            $(this).find('input[checked="checked"]').each(function(){
                optionItem++;
                answerList.push({
                    questionId: $(this).attr('name'),
                    questionChoiceId:$(this).attr('value')
                });
            });
        });
        /*获取多选*/

        $(".survey-answer ul.ul-option").each(function(){
            var i =0;
            // .checkbox-checked---选中项
            $(this).find('.check_box input:checked').each(function(){
                if(i==0){
                    optionItem++;
                }
                i++;
                answerList.push({
                    questionId: $(this).attr('name'),
                    questionChoiceId:$(this).attr('value')
                });
            });
        });
        /*获取填空*/
        $('#titleDetails').each(function(){
            var val = $(this).val();
            if(val && val!=''){
                optionItem++;
                answerList.push({
                    questionId: $(this).attr('name'),
                    otherAnwser:val
                });
            }
        });
        /*验证问卷题目数量和已回答的题目数是否匹配*/
        if(data_length == optionItem){
            submitData.questionnaireId = list_id;
            submitData.answerList = answerList;

            jomooAjax({
                apiLast:'question/saveAnswer',
                params:submitData,
                success:function(data){
                    if(data.status) {
                        $.alert("提交成功!", '', function () {
                            $(".queSurvey-list a[data-code='"+list_id+"']").attr("data-answer","true");
                            if(app.userInfo.type != 'employee'){
                                $(".queSurvey-list a[data-code='"+list_id+"']").remove();
                            }
                            $.router.back();
                        });
                    } else {
                        $.toast(data.errorMessage)
                    }
                }
            });
        }else{
            $.toast('请回答完所有题目');
        }
    });
    /*题目列表*/
    exports.getDetailHtml = function (id) {
        console.error('如果是查看结果，详情页的地步应该显示为“查看结果”按钮，点击后切换页面展示图表统计！\r\n需要根据实际结果判断，目前没有结果供调试');
        /*var flag = false;
        if(flag){
            *//*激活查看结果按钮*//*
            $('#submit').attr('id','').attr('class','chart-result').text('查看结果');
        }*/
        jomooAjax({
            "apiLast": 'question/questionInfo',
            "params": {questionnaireId:id},
            "success": function (data) {
                if(data.status){
                    if(data.detail.quetionList.length>0){
                        var new_date = new Date();
                        var new_year = parseInt(new_date.getFullYear())+'-'+parseInt(new_date.getMonth()+1)+'-'+parseInt(new_date.getDate());
                        var answer_val = '';
                        if(answer == "true" ){
                            answer_val = "true"
                        } else {
                            answer_val = "false"
                        }

                        data_length = data.detail.quetionList.length;
                        end_time ='';
                        end_time =data.detail.jmQuestionnaire.deadline;
                        var _html = '<div class="survey-title">' + data.detail.jmQuestionnaire.questinnaireTitle + '</div>';
                         _html += '<div  ><img  style="width: 100%;height: 150px" src="' +getImgUrl(data.detail.jmQuestionnaire.imgUrl) + '"/></div>';
                         _html += '<div style="padding: 0px 5px 10px 5px;font-size: 15px;" >' + data.detail.jmQuestionnaire.description + '</div>';
                        _html += '<div style="padding: 0px 5px 10px 5px;font-size: 15px;" >问卷结束时间：' + end_time + '</div>';

                        data = data.detail.quetionList;
                        var answer_html = '';

                        var cal = '';
                        for(var i=0;i<data.length;i++){
                            var _answer = ''
                                , _queId = data[i].id
                                , isRadio = data[i].typeCode ;// TMLX_DANX为单选
                            if(isRadio == "TMLX_TK"){
                                cal = '';
                                if(answer == "true"){
                                    cal = "disabled=disabled";
                                }
                                _answer += '<ul><li>';
                                _answer += '<textarea id="titleDetails" '+cal+' class="titleDetails" cols="50" rows="6" name="' + _queId + '"></textarea>';
                                _answer += '</li></ul>';
                            } else {
                                if (isRadio == "TMLX_DANX") {
                                    _answer += '<ul class="ul-raido">';
                                } else if (isRadio == "TMLX_DUOX") {
                                    _answer += '<ul class="ul-option">';
                                }

                                for (var j = 0; j < data[i].choice.length; j++) {
                                    answer_html = '';

                                    if(answer == "true"){

                                        answer_html = "("+data[i].choice[j].percent+"%)"
                                    }
                                    if (isRadio == "TMLX_DANX") {

                                        _answer += '<li><span class="radio_box">' +
                                        '<input type="radio" answer="'+answer_val+'" name="' + _queId + '" id="radio_' + _queId + j + '" value="' + data[i].choice[j].id + '">' +
                                        '<label for="radio_' + _queId + j + '"></label>' +
                                        '<em>' + data[i].choice[j].description +answer_html+ '</em>' +
                                        '</span></li>';
                                    } else if (isRadio == "TMLX_DUOX") {
                                        _answer += '<li><span class="check_box">' +
                                        '<input type="checkbox" answer="'+answer_val+'" name="' + _queId + '" id="checkbox_' + _queId + j + '" value="' + data[i].choice[j].id + '">' +
                                        '<label for="checkbox_' + _queId + j + '"></label>' +
                                        '<em>' + data[i].choice[j].description + answer_html+'</em>' +
                                        '</span></li>';
                                    }

                                };
                                _answer += '</ul>';
                            }
                            _html += '<div ><div>'
                            _html += '<div class="survey-answer" data-id=' + _queId + '>' +
                            '<span class="ans" style="margin-left: 5px">' + (i + 1) + '. ' + data[i].description + '</span>' +
                            _answer +
                            '</div>';
                        };
                        $("#page-queSurvey-detail .content").html(_html);
                        if(answer == "true"){
                            //if(end_time < new_year){
                                //$(".nav-bottom").show();
                                var bott_html = '<a id="ld_submit" data-id="'+id+'">查看结果</a>'
                                $(".nav_bott_li").html(bott_html);
                            /*} else {
                                $(".nav-bottom").hide();
                            }*/
                        } else {
                            //$(".nav-bottom").show();
                            $(".nav_bott_li").html("<a id='submit'>提交</a>");
                        }
                    }
                }
            }
        });
    };
    /*列表加载更多*/
    var addMoreList = function () {
        var  topicSearch = $("#search").val() || '';
        jomooAjax({
            "apiLast": 'question/list',
            "params": {search:topicSearch,p:p,s:s},
            "success": function (data) {
                if (data.status) {
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        for (var i = 0; i < data.length; i++) {

                            _html += '<a class="item-content clearfix item-link" data-answer='+data[i].answered+' data-description='+data[i].description+'  data-code=' + data[i].questionnaireId + ' id="questionList">';
                            _html += '<div class="cover-img ft-left">';
                            _html += '<img onerror="javascript:this.src=\'../public/images/moren1.png\';" src="'+getImgUrl(data[i].imlUrl)+'"/>';
                            _html += '</div>';
                            _html += '<div class="ft-sel">';
                            _html += '<span class="icon icon-right"></span>';
                            _html += '</div>';
                            _html += '<div class="ft-right">';i
                            _html += '<p class="item-title ellipsis">' + data[i].title + '</p>';
                            _html += '<p class="item-title ellipsis">' + data[i].description + '</p>';

                            _html += '<p class="gray">';
                            _html += '<span class="ft-left">题目数（' + data[i].questionCount + '）</span>';
                            _html += '<span class="ft-right">' + data[i].createTime + '</span>';
                            _html += '</p>';
                            _html += '</div>';
                            _html += '</a>';
                        }
                        if(data.length == s) {
                            _html += ' <div class="load-more" id="addMoreList"><span>查看更多</span></div>';
                        }
                        $(".queSurvey-list").html(_html);
                    } else {
                        if(p == 0) {
                            baseInfo.nodata(".queSurvey-list");
                        }

                    }
                }
            }
        });
    };

    var add_MoreList = function () {
        $(".load-more").remove();
        var  topicSearch = $("#search").val() || '';
        jomooAjax({
            "apiLast": 'question/list',
            "params": {search:topicSearch,p:p,s:s},
            "success": function (data) {
                if (data.status) {
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        for (var i = 0; i < data.length; i++) {

                            _html += '<a class="item-content clearfix item-link" data-answer='+data[i].answered+' data-description='+data[i].description+'  data-code=' + data[i].questionnaireId + ' id="questionList">';
                            _html += '<div class="cover-img ft-left">';
                            _html += '<img onerror="javascript:this.src=\'../public/images/moren1.png\';" src="'+getImgUrl(data[i].imlUrl)+'"/>';
                            _html += '</div>';
                            _html += '<div class="ft-sel">';
                            _html += '<span class="icon icon-right"></span>';
                            _html += '</div>';
                            _html += '<div class="ft-right">';i
                            _html += '<p class="item-title ellipsis">' + data[i].title + '</p>';
                            _html += '<p class="item-title ellipsis">' + data[i].description + '</p>';

                            _html += '<p class="gray">';
                            _html += '<span class="ft-left">题目数（' + data[i].questionCount + '）</span>';
                            _html += '<span class="ft-right">' + data[i].createTime + '</span>';
                            _html += '</p>';
                            _html += '</div>';
                            _html += '</a>';
                        }
                        if(data.length == s) {
                            _html += ' <div class="load-more" id="addMoreList"><span>查看更多</span></div>';
                        }
                        $(".queSurvey-list").append(_html);
                    }
                }
            }
        });
    };

    /*问题选项点击事件*/
    $(".radio_box,.check_box").live("click", function () {
        var _thisInput = $(this).find('input');
        if (_thisInput.attr("type") == "radio") {
            $("input[name='" + _thisInput.attr("name") + "']").removeAttr("checked");
            _thisInput.attr("checked", 'checked');
        } else {
            if (_thisInput.attr('checked')) {
                _thisInput.removeAttr("checked");
            } else {
                _thisInput.attr("checked", 'checked');
            }
        }
    });

    /*问卷结果分析*/
    $(document).on('click','#ld_submit',function(e){

        require.async(['../public/js/echarts'], function(){
            var _this = $(e.currentTarget)
                ,id = _this.attr('data-id');

            jomooAjax({
                apiLast:'question/analyzeData',
                params:{
                    questionnaireId:id
                },
                success:function(data){
                    if(!data)return;

                        $.router.load('#page-chart');
                        var radarChart = echarts.init(document.getElementById('radar-container'));
                    //if(data.detail.length>0) {
                        radarChart.setOption(dataReset_radar(data));
                    /*} else {
                        baseInfo.nodata("#radar-container");
                    }*/
                }
            });
            jomooAjax({
                apiLast:'question/marketData',
                params:{
                    questionnaireId:id
                },
                success:function(data){
                    if(!data)return;

                        var bubbleChart =  echarts.init(document.getElementById('bubble-container'));
                   // if(data.detail.length>0) {
                        bubbleChart.setOption(dataReset_bubble(data));
                    /*}else {
                        baseInfo.nodata("#bubble-container");
                    }*/
                    //$.router.load('#page-chart');

                }
            });
        });
    });

    /*数据重组-雷达*/
    var dataReset_radar = function(data){
        var data = data.detail
            ,eachData = data.productAnalyzeDtos//图例,产品类目;指标
            ,mapNav = data.dimensions
            ,option = {}
            ,title = {'text':''}
            ,legend = {}
            ,legendData = []
            ,radar = []
            ,indicator = []
            ,series = []
            ,seriesData = [];

        if(eachData.length > 0){
            legend.data = [];  //声明图例

            for(var _eachData=0;_eachData<eachData.length;_eachData++){
                /*图表中的图例*/
                legendData.push(eachData[_eachData].name);
                /*填充数据模板*/
                seriesData.push({
                    value: eachData[_eachData].scores,
                    name: eachData[_eachData].name,
                    symbol: 'rect',  //绘制纬度时的连接点的形状
                    symbolSize: 5,  //绘制纬度时的连接点的大小
                    lineStyle: {
                        normal: {
                            type: 'dashed'  //绘制纬度的线条样式
                        }
                    },
                    areaStyle: {
                        normal: {
                            color: 'rgba(255, 255, 255, 0.5)' //绘制出的纬度区域内的背景色
                        }
                    }
                })
            }

        }else{
            console.log('productAnalyzeDtos:后台并没有返回结果！');
        }
        $.extend(legend,{
            top:'30',
            center: ['50%', '60%'],
            data:legendData
        });
        if(mapNav.length>0){
            for(var _mapNav in mapNav){
                indicator.push({'text':mapNav[_mapNav]})
            }
        }else{
            console.log('dimensions:后台并没有返回结果');
        }

        /*雷达图属性配置*/
        radar.push({
            indicator:indicator,
            center: ['50%', '60%'],  //图表在页面中的位置
            radius: 90,  //图表的半径
            startAngle: 90,  //x正半轴逆时针旋转的角度（纬度1）
            splitNumber: 4,  //雷达图被分隔的数量（被多少个圆划分）
            shape: 'circle',  //雷达图背景的形状
            name: {
                formatter:'【{value}】',  //数据绑定：indicator
                textStyle: {
                    color:'#72ACD1'  //纬度名称的字体颜色
                }
            },
            splitArea: {
                areaStyle: {
                    color: ['rgba(114, 172, 209, 0.2)',  //纬度对应的雷达背景色；分隔数量比纬度多时，背景色随对象下标顺序指定的颜色扩散
                        'rgba(114, 172, 209, 0.4)',
                        'rgba(114, 172, 209, 0.6)',
                        'rgba(114, 172, 209, 0.8)',
                        'rgba(114, 172, 209, 1)'],
                    shadowColor: 'rgba(0, 0, 0, 0.3)',  //轮廓阴影颜色
                    shadowBlur: 10  //轮廓阴影厚度
                }
            },
            axisLine: {
                lineStyle: {
                    color: 'rgba(255, 255, 255, 0.5)'  //圆心发出指向各纬度的半径的线条颜色
                }
            },
            splitLine: {
                lineStyle: {
                    color: 'rgba(255, 255, 255, 0.5)'  //各纬度的边框颜色
                }
            }
        });
        /*雷达图数据配置*/
        series.push({
            name: '雷达图',
            type: 'radar',  //对应的图标类型
            itemStyle: {
                emphasis: {
                    // color: 各异,
                    lineStyle: {
                        width: 4  //focus时线条的厚度
                    }
                }
            },
            data: seriesData
        });

        option.title = title;
        option.legend = legend;
        option.radar = radar;
        option.series = series;
        return option;

    };
    /*数据重组-气泡*/
    var dataReset_bubble = function (data) {
        /*后台已经固定了4个维度，不会做更改*/
        var data = data.detail
            ,jomoo = [],product1 = [],product2 = [],product3 = []
            ,schema = [
                {name:'SCXYL',index:0,text:'市场吸引力'},
                {name:'CPJZL',index:1,text:'产品吸引力'}
            ]
            ,itemStyle = {
                normal: {
                    opacity: 0.9,
                    shadowBlur: 10,
                    shadowOffsetX: 0,
                    shadowOffsetY: 0,
                    shadowColor: 'rgba(255, 255, 2555, 0.5)'
                }
            };

        /*遍历数据*/
        console.log('===',data);
        if(data.length>0){
            for(var arr in data){
                /*获取scroes，将index[0]与index[1]之和推入scroes末尾，并返回新的scroes*/
                var item = data[arr].scores;
                item.map(function(value,index,array){
                    if(index>0)return;
                    return item.push(array[0]+array[1])
                });

                /*将scroes推入指定的数据模板*/
                arr==0?jomoo.push(item):
                    arr==1?product1.push(item):
                        arr==2?product2.push(item):
                            arr==3?product3.push(item):
                                console.log('异常！',item,jomoo,product1,product2,product3);
            }

        }else{
            console.log('后台没有返回与产品竞争力和市场吸引力的数据!')
        }

        var option = {
            backgroundColor: 'rgba(255,255,255,0)',
            color: [
                '#dd4444', '#fec42c','#9F79EE','#2ca3dd'
            ],
            legend: {
                center: ['50%', '60%'],
                y: 'top',
                data: ['九牧','竞品1', '竞品2','竞品3'],
                textStyle: {
                    color: '#231815',
                    fontSize: 16
                }
            },
            grid: {
                x: '15%',
                x2: '15%',
                y: '20%',
                y2: '17%'
            },
            tooltip: {
                padding: 10,
                backgroundColor: '#222',
                borderColor: '#777',
                borderWidth: 1,
                formatter: function (obj) {
                    var value = obj.value;
                    return schema[0].text + '：' + value[0] + '<br>'
                        +schema[1].text + '：' + value[1] + '<br>';
                }
            },
            xAxis: {
                type: 'value',
                name: '产品竞争力',
                nameGap: 30,
                nameLocation:'middle',
                nameTextStyle: {
                    color: '#231815',
                    fontSize: 14
                },
                max: 10,
                splitLine: {
                    show: false
                },
                splitNumber:5,
                axisLine: {
                    lineStyle: {
                        color: '#707070'
                    }
                }
            },
            yAxis: {
                type: 'value',
                name: '市场吸引力',
                nameLocation: 'middle',
                nameGap: 25,
                nameTextStyle: {
                    color: '#231815',
                    fontSize: 14
                },
                max:10,
                axisLine: {
                    lineStyle: {
                        color: '#707070'
                    }
                },
                splitLine: {
                    show: false
                }
            },
            visualMap: [
                {
                    show:false,
                    left: 'right',
                    top: '10%',
                    dimension: 2,
                    min: 0,
                    max: 20,
                    itemWidth: 30,
                    itemHeight: 120,
                    calculable: true,
                    precision: 0.1,
                    text: ['圆形大小：PM2.5'],
                    textGap: 30,
                    textStyle: {
                        color: '#fff'
                    },
                    inRange: {
                        symbolSize: [10, 70],
                        colorLightness: [1, .5]
                    },
                    outOfRange: {
                        symbolSize: [10, 70],
                        color: ['rgba(255,255,255,.2)']
                    }
                }
            ],
            series: [
                {
                    name: '九牧',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: jomoo
                },
                {
                    name: '竞品1',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product1
                },
                {
                    name: '竞品2',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product2
                },
                {
                    name: '竞品3',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product3
                }
            ]
        };

        return option;
    };
});
