/**
 * Created by Sa on 2016-12-29.
 */
define(function(require, exports, module) {

    var pageParam = {};

    $(document).on('pageInit','#page-search-result',function(e,pageId,$page){
        /*初始化页面后，获取展示结果的容器*/
        pageParam.resultEle = document.getElementById('search-result');
        /*标识请求是否正在进行*/
        pageParam.ajaxFlag = false;
        /*初始化页面后，记录页面的时间*/
        pageParam.pageMs = (new Date()).getTime();
        //var toolbarH = $('header').height()
        //    ,navH = ($('nav')&&$('nav').length==1)?($('nav')[0].offsetHeight):0;
        //console.log(toolbarH,navH);
        ///*重置页面高度*/
        //$('.page-current .content').height(baseInfo.windowHeight - toolbarH - navH);
    });

    $(document).on('input','#search',function(e){
        /*清空结果*/
        pageParam.resultEle.innerHTML = '';
        /*在输入状态下时间间隔超过800ms,未请求或请求已经结束时才开始下一次请求*/
        if(!poorTime() && !pageParam.ajaxFlag)return;
        /*
        * 输入时,应每隔一段时间才开始请求，开始请求前终止当前请求
        * 请求成功后渲染数据到页面，#search-input
        * */
        //pageParam.searchRequest.abort();
        /*如果input的值为空，则不搜索*/
        //`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？
        var _this = $(e.currentTarget)
            ,pattern = new RegExp("[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？]",'g')
            //,_keyWord = _this.val().replace(!/\d|\w|[\u4e00-\u9fa5]/g,'');
            ,_keyWord = _this.val().replace(pattern,'');
        if(!_keyWord)return;
        console.log('input:',_keyWord);
        pageParam.searchRequest = jomooAjax({
            apiLast:'common/search',
            type:'get',
            params:{
                keyWord:_keyWord,
                p:0,
                s:10
            },
            //url:'../tempData/searchData.json',
            beforeSend:function(xhr,setting){
                /*请求开始*/
                pageParam.ajaxFlag = true;
                /*发送请求前，将pageParam.searchFlag的值设置为true，以免频繁发送服务器请求*/
                pageParam.pageMs = (new Date()).getTime();
            },
            complete:function(xhr,status){
                /*请求完成*/
                pageParam.ajaxFlag = false;
                /*请求完成后，重置搜索状态*/
                pageParam.pageMs = (new Date()).getTime();
            },
            success:function(data){
                if(!data)return;
                var _data = data.list
                    ,l = _data.length;
                if(l){
                    pageParam.resultEle.innerHTML = '';
                    for(var i=0;i<l;i++){

                        var reg = new RegExp(_keyWord,'g')
                            ,p = document.createElement('p');
                        /*如果匹配不到结果就return,否则返回结果到页面*/
                        //if(reg.test(_data[i].title)) {

                            p.innerHTML = _data[i].title.replace(reg, '<em>' + _keyWord + '</em>');
                            pageParam.resultEle.appendChild(p);
                        //}
                    }
                }
                console.log('search result:');

            }
        });
    });

    var poorTime = function(){
        /*获取当前时间的毫秒数*/
        var curTiime = (new Date()).getTime();
        console.log('poor ms:',curTiime-pageParam.pageMs);
        if(curTiime-pageParam.pageMs > 500) {
            return true;
        }else {
            return false;
        }
    }
});
