﻿$(function () {

    var p = 0//当前第几页
            , s = 10//每页显示多少条
    ;

    $(document).on("pageInit", ".page", function (e, id, page) {

        //获取详情
        getDetailHtml();
        //获取第一页评论
        addItems();

        /*上拉加载更多*/
        var loading = false;        
        $(page).on('infinite', function () {
            // 如果正在加载，则退出
            if (loading) return;
            // 设置flag
            loading = true;
            // 模拟1s的加载过程
            setTimeout(function () {
                p++;//页数+1
                addItems();
                // 重置加载flag
                loading = false;
                $.refreshScroller();
            }, 1000);
        });
    });

    /*获取详情*/
    var getDetailHtml = function () {
        $.ajax({
            type: 'GET',
            url: 'https://www.baidu.com/',
            async: false,
            data: { q: 'detail' },
            timeout: 10000,
            success: function (data) {
                data = {
                    "status": true,
                    "errorCode": "200",
                    "errorMessage": "",
                    "detail": {
                        title: "花洒新颖设计",
                        source: "九牧官网",
                        createTime: "2016-08-03 12:36",
                        content: "&nbsp;&nbsp;&nbsp;&nbsp;九牧的淋浴器厂商宣布推出一套循环水淋浴装置。九牧表示，" +
                        "这款产品是和美国NASA合作研发，循环水的水质高于水龙头的自来水水质。" +
                        "这种循环水淋浴装置通过不断清理和循环使用水进行节水。九牧声称，" +
                        "节水率高达90%，能量使用效率提升80%。九牧研发的循环水淋浴装置有两种形式，" +
                        "一种是一个独立的机柜，另一个是与地板结合。" +
                        "<div style='text-align: center;'><img src='../public/images/ICON.png'></div>" +
                        "&nbsp;&nbsp;&nbsp;&nbsp;九牧表示，在这种设备当中，喷头喷出水经过身体之后，" +
                        "然后流入一个设有微胶囊和纳米胶囊的搜集装置。所述微胶囊除去水中较大污染颗粒，" +
                        "纳米胶囊除去像病菌，金属和乳化油等微小颗粒，使得净化出来的水质高于自来水水质。" +
                        "&nbsp;&nbsp;&nbsp;&nbsp;每个微胶囊和纳米胶囊售价分别为25美元和100美元，分别可以处理8000加仑洗澡水和26000加仑洗澡水。" +
                        "循环水淋浴装置地板集成版本价格为4000美元，机柜版本售价为5000美元。",
                        lookNum: 13,
                        commentNum: 8
                    }
                };

                var _html = '';
                _html += '<p class="detail-title">' + data.detail.title + '</p>';
                _html += '<p class="detail-source">';
                _html += '<span>' + data.detail.source + '</span>';
                _html += '&nbsp;&nbsp;<span>' + data.detail.createTime + '</span>';
                _html += '&nbsp;&nbsp;<span class="icon reads-icon"><labe>' + data.detail.lookNum + '</labe></span>';
                _html += '<span class="icon comments-icon"><labe>' + data.detail.commentNum + '</labe></span>'
                _html += '</p>';
                _html += '<div class="detail-text">' + data.detail.content + '</div>';
                $(".detail-content").html(_html);

                var _html = '<div class="allComment">最新评论</div>';
                _html += '<div class="commentLi">';
                _html += '</div>';
                $(".detail-comment").html(_html);
            },
            error: function (xhr, type) {
                $.alert(type);
            },
            beforeSend: function (xhr, settings) {
                $.showPreloader();
            },
            complete: function (xhr, status) {
                $.hidePreloader();
            }
        });
    }

    /*详情页底部bar点击事件*/
    $(document).on("click", ".bar-tab a", function () {
        var id = $(this).attr("id");
        if (id == 'commentsBtn') {
            var popupHTML = '<div class="popup popup-comment">' +
                    '<div class="content-block">' +
                      '<ul><li><a class="close-popup">取消</a></li><li>评论</li><li><a id="sendMess" class="gray">发送</a></li></ul>' +
                      '<textarea id="txtarea-comment" placeholder="请输入评论内容"></textarea >' +
                    '</div>' +
                  '</div>'
            $.popup(popupHTML);
            //$("#txtarea-comment").focus();//加了聚焦之后页面会闪一下
        }
    });

    /*点击遮罩层关闭评论modal*/
    $(document).on("click", ".popup-overlay", function () {
        $(this).removeClass('modal-overlay-visible')
        $.closeModal('.popup-comment');
    });

    /*textarea输入监控*/
    $(document).on("input oninput", "#txtarea-comment", function () {
        if ($.trim($(this).val()).length > 0) {
            $("#sendMess").removeClass('gray')
        } else {
            $("#sendMess").addClass('gray')
        }
    });

    /*点击发送*/
    $(document).on("click", "#sendMess", function () {

        var mess = $.trim($("#txtarea-comment").val());
        if (mess.length > 0) {
            var _html = '';

            _html += '<li>';
            //头像
            _html += '<div class="comment-userImg"><img src="' + '../public/images/ICON.png' + '"></div>';
            //用户名
            _html += '<div class="comment-userName">';
            _html += '<span>' + '啦啦啦' + '</span>';
            _html += '<span>' + '8' + '</span>';
            _html += '<span class="gray">' + getCurentTime() + '</span>';
            _html += '</div>'
            //内容
            _html += '<div class="comment-text">' + mess + '</div>';
            _html += '</li>';


            $(".commentLi").prepend(_html);

            $('.popup-overlay').removeClass('modal-overlay-visible')
            $.closeModal('.popup-comment');
        }
    });

    /*评论加载更多*/
    var addItems=  function () {
        $.ajax({
            type: 'GET',
            url: 'https://www.baidu.com/',
            async: false,
            data: { type: 'comment', p: p, s: s },
            timeout: 10000,
            success: function (data) {
                data = {
                    "status": true,
                    "errorCode": "200",
                    "errorMessage": "",
                    "list": [{
                        id: 1,
                        userName: '张三',
                        userImg: '../public/images/ICON.png',
                        userLevel: 0,
                        commentContent: '加油！不错哦！',
                        commentDate: '7小时前'
                    }, {
                        id: 2,
                        userName: '李四',
                        userImg: '../public/images/ICON.png',
                        userLevel: 1,
                        commentContent: '好东西呀，以后可以谁在浴室了。',
                        commentDate: '12小时前'
                    }, {
                        id: 3,
                        userName: '王五',
                        userImg: '../public/images/ICON.png',
                        userLevel: 2,
                        commentContent: '哈啊啊啊啊啊内容很长很长要换行哈哈哈哈哈哈哈哈哈哈',
                        commentDate: '2016-09-01 09:01'
                    }, {
                        id: 4,
                        userName: '沼柳',
                        userImg: '../public/images/ICON.png',
                        userLevel: 3,
                        commentContent: '嗯我喜欢哈哈哈哈',
                        commentDate: '2016-09-23 16:54'
                    }]
                };
                if (p == 5) data.list = [];//模拟第6页的时候数据返回空
                if (data.status) {
                    if (data.list.length > 0) {
                        var _html = '';
                        $.each(data.list, function () {
                            _html += '<li>';
                            //头像
                            _html += '<div class="comment-userImg"><img src="' + this.userImg + '"></div>';
                            //用户名
                            _html += '<div class="comment-userName">';
                            _html += '<span>' + this.userName + '</span>';
                            _html += '<span>' + this.userLevel + '</span>';
                            _html += '<span class="gray">' + this.commentDate + '</span>';
                            _html += '</div>'
                            //内容
                            _html += '<div class="comment-text">' + this.commentContent + '</div>';
                            _html += '</li>';
                        });
                        $(".commentLi").append(_html);
                    } else {
                        // 加载完毕，则注销无限加载事件，以防不必要的加载
                        $.detachInfiniteScroll($('.infinite-scroll'));
                        // 删除加载提示符
                        $('.infinite-scroll-preloader').remove();
                    }
                }
            },
            error: function (xhr, type) {
                $.alert(type);
            },
            beforeSend: function (xhr, settings) {
                $.showPreloader();
            },
            complete: function (xhr, status) {
                $.hidePreloader();
            }
        });
    }
    
    /*获取当前时间yyyy-MM-dd HH:MM*/
    var getCurentTime= function () {
        var now = new Date();

        var year = now.getFullYear();       //年
        var month = now.getMonth() + 1;     //月
        var day = now.getDate();            //日

        var hh = now.getHours();            //时
        var mm = now.getMinutes();          //分

        var clock = year + "-";

        if (month < 10)
            clock += "0";

        clock += month + "-";

        if (day < 10)
            clock += "0";

        clock += day + " ";

        if (hh < 10)
            clock += "0";

        clock += hh + ":";
        if (mm < 10) clock += '0';
        clock += mm;
        return (clock);
    }

    $.init();//初始化 
});