/**
 * Created by Sa on 2016-09-20.
 */
define(function(require, exports, module) {
    var pageParam = {};


    $(document).on('pageInit','#page-home',function(e,pageId,$page){
        pageInit();

        var toolbarH = $('header').height()
            ,navH = ($('nav')&&$('nav').length==1)?($('nav')[0].offsetHeight):0;
        console.log(toolbarH,navH);
        /*重置页面高度*/
        $('.page-current .content').height(baseInfo.windowHeight - toolbarH - navH);
    });

    /* 页面初始化 */
    function pageInit(){

        /*加载轮播图*/
        jomooAjax({
            apiLast:'common/homeCarouselPicture',
            type:'GET',
            beforeSend: function(){},
            success:function(data){
                if(!data)return;
                if(data.list.length > 0){
                    var html = '';
                    data = data.list;
                    var  type_val = '';
                    for(var i=0;i<data.length;i++){
                        html += '<div class="swiper-slide home-cover-swiper"><input type="hidden" data-id="'+data[i].id+'" data-code="'+data[i].code+'" />' +
                        '<a href="javascript:void(0)">' +
                        '<img onerror="javascript:this.src=\'../public/images/moren1.png\';" ' +
                        'src="'+(data[i].url!=''? getImgUrl(data[i].url):'../public/images/moren1.png')+'" alt=""></a></div>';
                    }
                    $('.swiper-wrapper').html(html);

                    $.reinitSwiper();
                }
            }
        });

        /*加载创意大赛，技术需求*/
        jomooAjax({
            apiLast:'common/homeCreativityCenter',
            type: 'get',
            beforeSend: function(){},
            success: function(data){
                if(!data)return;
                $('.magic-center').html(cardHtml(data.dto));
            }
        });

        /*最新资讯*/
        jomooAjax({
            apiLast:'newestInfo/list',
            params:{type:'',p:0,s:3},
            beforeSend: function(){},
            success:function(data){
                if(!data)return;
                data = data.list;
                var html = hotNewsHtml(data);
                $('div.hot-news').html(html);
            }
        });
    }

    /* 创意活动/设计需求/设计方案 */
    var cardHtml = function(data){
        var defaultImg = '../public/images/moren1.png'
            ,img1 = data.matchs.length?data.matchs[0].imgUrl:defaultImg
            ,img2 = data.designs.length?data.designs[0].imgUrl:defaultImg
            ,img3 = data.techniques.length?data.techniques[0].imgUrl:defaultImg;
        var html = '';
        html += '<div class="magic-left">';
        html += '<img src="'+getImgUrl(img1)+'" data-code="'+data.matchs[0].code+'" data-type="'+data.matchs[0].type+'" data-title="'+data.matchs[0].title+'" alt=""/>';
        //html += '<p class="des-title">'+data.matchs[0].title+'</p>';
        //html += '<p class="des-type">创意大赛</p>';
        html += '</div>';
        html += '<div class="magic-rightTop">';
        html += '<img src="'+getImgUrl(img2)+'" data-code="'+data.designs[0].code+'" data-type="'+data.designs[0].type+'" data-title="'+data.designs[0].title+'" alt=""/>';
        //html += '<p class="des-title">'+data.designs[0].title+'</p>';
        //html += '<p class="des-type">设计需求</p>';
        html += '</div>';
        html += '<div class="magic-rightBottom">';
        html += '<img src="'+getImgUrl(img3)+'" data-code="'+data.techniques[0].code+'" data-type="'+data.techniques[0].type+'" data-title="'+data.techniques[0].title+'" alt=""/>';
        //html += '<p class="des-title-right-bottom">'+data.techniques[0].title+'</p>';
        //html += '<p class="des-type-right-bottom">技术需求</p>';
        html += '</div>';

        return html;
    };

    /* 最新资讯 */
    var hotNewsHtml = function(data){
        var html = '';
        for(var i=0;i<data.length;i++){
            html += '<div class="card-news" data-id="'+data[i].id+'">';
            html += '<img onerror="javascript:this.src=\'../public/images/moren1.png\';" class="li-img" src="'+getImgUrl(data[i].coverImg)+'" alt=""/>';
            html += '<span>'+data[i].title+'</span>';
            html += '</div>';
        }

        html += '<a class="more-news">查看更多资讯>></a>';

        return html;
    };
    
    // 查看更多资讯
    $(document).on('click', '.more-news', function(){
        require.async(['../newsList/newsList.css', '../newsList/index'], function(){
            $.router.load('../newsList/index.html');
        });
    });

    /* banner click evt */
    $(document).on('click','.home-cover-swiper',function(e){

        var _this = $(e.currentTarget)
            ,id   = _this.find('input[type="hidden"]').attr('data-id')
            ,code = _this.find('input[type="hidden"]').attr('data-code')
            ,type = code.indexOf('XPSY') > -1 ? 'XPSY' : code.indexOf('ZC') > -1 ? 'ZC' : 'WJDC';
        
        if(type === 'WJDC' && isLogin()){

            require.async(['../queSurvey/index.js','../queSurvey/queSurvey.css'],function(a){
                a.getDetailHtml(id);
                $.router.load('../queSurvey/index.html#page-queSurvey-detail');
            });
        }else if(type === "XPSY"){
            require.async(['../tryout/tryout.js', '../tryout/tryout.css'],function(detailPage){
                detailPage.loadDetail_product(id,true);
            });
        }else if(type == 'ZC'){
            require.async(['../indiegogo/indiegogo.js', '../indiegogo/indiegogo.css'],function(detailPage){
                detailPage.loadDetail_indiegogo(id);
            });
        }
    });

    /* 新闻列表 */
    $(document).on('click','.hot-news-list',function(){
        console.log('click  new list');
        var ids = ['../newsList/index.js','../newsList/newsList.css'];
        require.async(ids,function(){
            $.router.load('../newsList/index.html');
        });
    });

    /* 新闻详情 */
    $(document).on('click','.card-news',function(e){
        console.log('click news');  
        var _this = $(e.currentTarget)
            ,id = _this.attr('data-id')
            ,ids = ['../newsList/index.js','../newsList/newsList.css'];

        require.async(ids,function(exports){
            exports.getDetailHtml(id);
            $.router.load('../newsList/index.html#page-news-detail');
        });
    });

    /*功能区模块跳转*/
    $(document).on('click','.fn-area a',function(e){

        var jumpModule = $(e.currentTarget).attr('data-page');

        switch(jumpModule){
            /* 创意活动模块 */
            case 'creativeCYHD': require.async(['../creativityCenter/creativity'], function(a) {
                    a.toPage({
                            isMy     : 'N',
                            pageType : 'list',
                            type     : 'CYHD',
                        }).go();
                });
            break;
            /* 自由创意模块 */
            case 'creativeZYCY': require.async(['../creativityCenter/creativity'], function(a) {
                    a.toPage({
                            isMy     : 'N',
                            pageType : 'list',
                            type     : 'ZYCY',
                        }).go();
                });
            break;
            case 'tryout' :
                $.showIndicator();
                require.async(['../tryout/tryout.js', '../tryout/tryout.css'], function(op){
                    $.router.load('../tryout/tryout.html');
                });
                break;
            case 'indiegogo' :
                $.showIndicator();
                require.async(['../indiegogo/indiegogo.js', '../indiegogo/indiegogo.css'], function(op){
                    $.router.load('../indiegogo/indiegogo.html');
                });
            break;
            /* 调查问卷模块 */
            case 'queSurvey' :  if(isLogin()){
                                    require.async(['../queSurvey/index', '../queSurvey/queSurvey.css'], function(){
                                        $.router.load('../queSurvey/index.html');
                                    });
                                }
            break;
            /* 积分商城模块 */
            case 'pointsMall' :  if(isLogin()) {
                                    require.async(['../pointsMall/index', '../pointsMall/pointsMall.css'], function(){
                                        $.router.load('../pointsMall/index.html');
                                    });
                                 }
            break;
            /* 积分榜模块 */
            case 'scoreBoard' :  if(isLogin()){
                                    require.async(['../scoreBoard/index', '../scoreBoard/scoreBoard.css'], function(){
                                        $.router.load('../scoreBoard/index.html');
                                    });
                                 }
            break;
            default : console.error('找不到模块:' + jumpModule);
        }
    });

    /* 事件监听 */
    $(document).on('pageInit', "#page-creative", function (e, pageId, $page) {

        /*页面中显示导航栏时，需要重置.content高度*/
        if($('.bar-tab').css('display') == 'block') {
            var $content = $('.content')
                , $barNavH = $('.bar-nav').height()
                , $barTabH = $('.bar-tab').height();
            $content.height(baseInfo.windowHeight - $barNavH - $barTabH);
        }

        
        $('.selectList').hide(); // 隐藏
            
        if(app.isPageBack(pageId)) return;

        var pageMenu = {
            "pageInfo": ["活动创意", "自由创意"],
            "pageIndex": []
        };

        jomooAjax({
            apiLast: 'common/creativityCenter',
            params: {
                p: baseInfo.pageIndex,
                s: 3,
                type:'CYHD'  //创意活动
            },
            success: function (data) {
                
                pageParam.createList = data.list;

                pageParam.pageInfo = {
                    "pageKey"    : ['creative', 'magic'],    /* 页签key值 */
                    "pageName"   : ['创意活动', '自由创意'], /* 页签要显示的名称 */
                    "pageContent": []
                };
                pageParam.titleInfo = {
                    "creative": {
                        "matchs"    : {"type": 'MK_CYDS', "title": "创意大赛", "clsName": "creative-icon"},
                        "designs"   : {"type": 'MK_SJXQ', "title": "设计需求", "clsName": "design-icon"},
                        "techniques": {"type": 'MK_JSXQ', "title": "技术需求", "clsName": "technology-icon"}
                    },
                    "magic": {
                        "designPlan"   : {"type": 'MK_SJFA', "title": "设计方案", "clsName": "design-plan-icon"},
                        "techniquePlan": {"type": 'MK_JSFA', "title": "技术方案", "clsName": "technology-plan-icon"},
                        "ideas"        : {"type": 'MK_QSMX', "title": "奇思妙想", "clsName": "magic-plan-icon"}
                    }
                };

                /*加载页面*/
                creativeHtml(pageParam.createList);
                jomooAjax({
                    apiLast: 'common/creativityCenter',
                    params: {
                        p: baseInfo.pageIndex,
                        s: 3,
                        type:'ZYCY'  //创意活动
                    },
                    success: function (data) {
                        $.hideIndicator();
                        pageParam.createList = data.list;
                        magicHtml(pageParam.createList);
                        $('#page-creative .content').html(baseInfo.createPageTag(pageParam.pageInfo));
                    }
                });
            }
        }); 
    });


    /* 路由到创意活动/奇思妙想 */
    $(document).on('click','#page-creative a.icon-link',function(e){ 

        var type = $(e.currentTarget).attr('data-type');

        require.async('../creativityCenter/creativity',function(targetPage){
            var param = {
                isMy    : 'N',
                pageType: 'list',
                type    : type
            };
            targetPage.toPage(param).go();
        });
    });

    /* 创意中心详情 */
    $(document).on('click', '.magic-center img', function (e) {

        var $e   = $(e.currentTarget),
            code = $e.data('code'), 
            type = $e.data('type'),
            title= $e.data('title');

        var params = {
            isMy    :'N',
            pageType:'detail',
            code    : code,
            title   : title,
            type    : type
        };
        require.async('../creativityCenter/creativity',function(fn){
            fn.toPage(params).go();
            // 阅读数
            setTimeout(function(){
                var _num = $e.find('.reads-icon').text();
                _num && _num.trim() !== '99+' && $e.find('.reads-icon').text(helper.nc(Number(_num) + 1));
            }, 200);
        });
    });

    /* 创意活动页 */
    var creativeHtml = function (data) {
        console.info('进入创意中心!');
        var createList = pageParam.createList;

        /* 标题下的内容 */
        for (var key in createList) {
            if (key != 'matchs' && key != "designs" && key != 'techniques')continue;
            var content = '';

            for (var j = 0; j < createList[key].length; j++) {
                /*活动创意模板*/
                content += '<ul class="c-content to-detail-page" data-title="' + createList[key][j].title  + '" data-code="' + createList[key][j].code + '" data-type="' + createList[key][j].type + '" >';
                content += '<li class="li-first"><img onerror="javascript:this.src=\'../public/images/moren1.png\';" class="li-img" src="' + getImgUrl(createList[key][j].imgUrl) + '" alt=""/></li>';
                content += '<li class="li-title ellipsis">' + createList[key][j].title + '</li>';
                content += '<li class="li-description double-row">' + createList[key][j].introduction + '</li>';
                content += '<li class="li-author"><span>' + createList[key][j].createDate.substring(0, 10) + '</span></li>';
                content += '<li class="li-last"><span class="icon cc-icon reads-icon">' 
                        +   helper.nc(createList[key][j].readCount) 
                        +  '</span><span class="icon cc-icon comments-icon">' 
                        +   helper.nc(createList[key][j].commentCount) + '</span><span class="icon cc-icon favorite-icon">' 
                        +   helper.nc(createList[key][j].likeCount == '' ? 0 : createList[key][j].likeCount) + '</span></li>';
                content += '</ul>';
            }
            $.extend(pageParam.titleInfo.creative[key], {"content": content});
        }

        var _areaInfo = baseInfo.createAreaInfo(pageParam.titleInfo.creative);

        /* 单个标题和内容的区块 */
        pageParam.pageInfo.pageContent.push(_areaInfo);
    };

    /* 自由创意 */
    var magicHtml = function (data) {
        var magicList = pageParam.createList;

        /* 标题下的内容 */
        for (var key in magicList) {
            if (key != 'ideas' && key != "techniquePlan" && key != 'designPlan')continue;
            var content = '';
            if (magicList[key].length < 1)continue;
            for (var j = 0; j < magicList[key].length; j++) {
                /*活动创意模板*/
                content += '<ul class="c-content magic-ul" data-title="' + magicList[key][j].title + '" data-code="' + magicList[key][j].code + '" data-type="' + magicList[key][j].type + '" >';
                // content += '<input type="hidden" data-code="' + magicList[key][j].code + '" data-type="' + magicList[key][j].type + '" />';
                content += '<li class="li-first author-img-li"><img onerror="javascript:this.src=\'../public/images/moren2.png\';" class="li-img" src="' + baseInfo.imgUrl + magicList[key][j].createUrl + '" alt=""/></li>';
                content += '<li class="li-title ellipsis single-row">' + magicList[key][j].title + '</li>';
                content += '<li class="li-nickName">' + magicList[key][j].createName + '</li>';
                content += '<li class="li-last"><span>' + magicList[key][j].createDate.substring(0, 10) + '</span></li>';
                content += '</ul>';
            }
            try {
                $.extend(pageParam.titleInfo.magic[key], {"content": content});
            } catch (e) {
                console.log(e)
            }
        }
        var _areaInfo = baseInfo.createAreaInfo(pageParam.titleInfo.magic);
        
        /*单个标题和内容的区块*/
        pageParam.pageInfo.pageContent.push(_areaInfo);
    };

    /*首页搜索*/
    $(document).on('click','.home-search',function(){
        var ids = ['../searchPage/searchPage.js','../searchPage/searchPage.css'];
        require.async(ids,function(){
            $.router.load('../searchPage/searchPage.html');
        })
    });

});
