;
define(function(require, exports, module) {
		
	// 在这里请求资源
	require('./jquery.min');
	require('./lrz.all.bundle');

	$.noConflict();    // 处理jQuery冲突
	var $$ = jQuery;

	var imgUpLoader = function(param){
		this.isCrop   = param.isCrop;   // 是否需要经过裁减
		this.trigger  = param.trigger;
		this.fn       = param.fn;
		this.isMultiple = param.isMultiple;
		this.imgWidth = param.imgWidth;
	}

	imgUpLoader.prototype.init = function(){

		var self = this,
			$img;

		$$(function() {
			// 如果isCrop为true 不能上传多张照片
			
	        $$(self.trigger + ' input.img-uploader').size() || 
	        $$(self.trigger).append('<input type="file"  accept="image/*" class="img-uploader" ' + (!self.isCrop && self.isMultiple ? 'multiple' : '') + ' style="opacity: 0;" capture="camera"/>');

	        // 上传照片结束
	        $$(self.trigger + ' .img-uploader').change(function() {

	        	var thisFiles = this.files,
	        		thisInput = this;

			    var isError = false;

		        for(var i = 0; i < this.files.length; i++){
		        	
		        	if(isError) return;

	        		lrz(this.files[i], {
		                width: (self.imgWidth && 200)         // 压缩之后的图片高度
		            }).then(function(rst) {
						self.fn && self.fn(rst.base64);
		            }).catch(function(err){
		            	if(!isError){
			            	$.toast(err);
			            	isError = true;
		            	}
		            }).always(function(){
	        			thisInput.value = null;                // 清空数据 可以重复选择
		            });
		        }
	        })
	    })
	}

	exports.imgUpLoader = imgUpLoader;
});
