$(function() {
    'use strict';
    var console = window.console || {
        log: function() {}
    },Orientation;

    // Demo
    // -------------------------------------------------------------------------
    (function() {
        var $image = $('.img-container > img'),
        $avatarData = $('#avatarData'),
        options = {
            aspectRatio: 1.55764192139738,
            preview: '.img-preview'
        };

        $image.cropper(options);
		if (1==2) {
			// Import image
			var $inputImage = $('#inputImage');
			
			$inputImage.change(function() {
				console.log(9999);
				var files = this.files,startTime = new Date().getTime(),file;
				$(".max-loading").show().children(".loadingTxt").html("正在缓存图片中<br>请耐心等候！");
				if (files && files.length) {
					file = files[0];
					
					if (/^image\/\w+$/.test(file.type)) {
						var imgresult;
						var oFReader = new FileReader();
						oFReader.readAsDataURL(files[0]);
						oFReader.onload = function (e) {
							imgresult = this.result;
							ImageOrientationFix({
								image:imgresult
								,onFix:function(base64_str){
									file = base64_str;
									
									$('.img-container img').attr("src",file);
									$image.one('built.cropper',function() {
										$(".max-loading").hide();
										var endTime = new Date().getTime();//接受时间
										//okmotify("IOS缓存"+(endTime - startTime)+"ms");
									}).cropper('reset', true).cropper('replace', file);
									
									$(".upimg-pop-box").show();
									
									$inputImage.val('');
								}
							});
						};
						
					} else {
						errormotify('请上传图片文件！');
					}
				}
			});
		}else if(1==3){
			  var $inputImage = $('#inputImage'),
				  URL = window.URL || window.webkitURL,
				  blobURL;
		  
			  if (URL) {
				$inputImage.change(function () {
				  var files = this.files,file,startTime = new Date().getTime();
				  $(".max-loading").show().children(".loadingTxt").html("正在缓存图片中<br>请耐心等候！");
		  
				  if (files && files.length) {
					file = files[0];
		  
					if (/^image\/\w+$/.test(file.type)) {
						var reader = new FileReader(); 
						reader.readAsDataURL(file); 
						reader.onload = function(e){ 
							  blobURL = this.result;
							  $('.img-container img').attr("src",blobURL);
							  $image.one('built.cropper', function () {
								  URL.revokeObjectURL(blobURL); // Revoke when load complete
								  $(".max-loading").hide();
								  var endTime = new Date().getTime();//接受时间
								  //okmotify("安卓缓存"+(endTime - startTime)+"ms");
							  }).cropper('reset', true).cropper('replace', blobURL);
							  
						} 
						$(".upimg-pop-box").show();
						$inputImage.val('');
					} else {
						errormotify('请上传图片文件！');
					}
				  }
				});
			  } else {
				$inputImage.parent().remove();
			  }
		}else{
			var $inputImage = $('#inputImage');
			
			$inputImage.change(function() {
				var files = this.files,file,startTime = new Date().getTime();
				lrz(files[0], {
					width: 800
				}).then(function (rst) {
						var file = rst.base64;
						$('.img-container img').attr("src",file);
						$image.one('built.cropper',function() {
							$(".max-loading").hide();
							var endTime = new Date().getTime();//接受时间
							//okmotify("缓存时间"+(endTime - startTime)+"ms");
						}).cropper('reset', true).cropper('replace', file);
						
						$(".upimg-pop-box").show();
						
						$inputImage.val('');
						
				});
				
			});
				
		}
		
        
		

       // Options
        $('a.aspestRatio').on('click',function() {
			$(this).addClass("cur").siblings("a").removeClass("cur");
			$('.img-container > img').cropper("setAspectRatio", $(this).data("value"));
			MZJS.Memoir.ModelChoice($(this).data("type"));
        });
        $('input.ConfirmPic').on('click',function() {
			var startTime = new Date().getTime();
			$(".max-loading").show().children(".loadingTxt").html("正在上传图片到服务器<br>请耐心等候！");
			var options = {
				width: 500,
				height: 500
			};  
			
			var result = $('.img-container > img').cropper("getCroppedCanvas",options);
			//$(".myCanvas").html(result);
			var Pic = result.toDataURL("image/jpg");
			console.log(Pic);

			$('body').append('<img src="' + Pic + '" alt="" />');
			Pic = Pic.replace(/^data:image\/(png|jpg);base64,/, "");
			
			$(".docs-View").html(result);
        });

    } ());

});