﻿define(function(require, exports, module){

    require('../public/js/md5.js');
$(function () {

    var infoId      = '', // 我的消息ID;
        myDetail    = [], // 我的信息
        My_img      = '', // 我的头像
        save_img    = '', // 保存头像
        _setInterval= '', // 计时器
        signScore   = 0 , // 签到积分
        p_x         = 0 ,
        s_x         = 10,
        p_h         = 0 ,
        s_h         = 10,
        p_j         = 0 ,
        s_j         = 10,
        p_JF        = 0 ,
        s_JF        = 10;

    $(document).on("pageInit", ".page", function (e, id, page) {

        switch(id){
            case 'page-point-list'  : initMyInfo();       // 初始化我的页面
            break;
            case 'page-point'       : addItems();         // 积分规则
            break;
            case 'page-score-Info'  : selectScoreInfo();  // 积分详情
            break;
            case 'page-my-Info'     : selectInfo();       // 我的消息
            break;
            case 'page-my-Info-list': selectInfoList();   // 消息列表
            break;
            case 'page-collection'  : selectCollection(); // 我的收藏
            break; 
            case 'page-my-score'    : if(myDetail){       // 我的积分
                                         $("#useableScore").val(myDetail.useableScore || 0);
                                         $("#frozenScore").val(myDetail.frozenScore || 0);
                                      }
            break;
            case 'page-Upmy-Info'   : selectMyInfo();     // 完善个人信息保存
            break;                                        // 上传图片
            case 'page-upImg'       : if(save_img){$('.img-list').html('<img src="'+save_img+'"  onerror="javascript:this.src=\'../public/images/moren2.png\';" />');}else{$('.img-list').html('<img src="'+getImgUrl(My_img)+'"  onerror="javascript:this.src=\'../public/images/moren2.png\';" />');}
            break;
        }
    });
    
    $(document).one('pageAnimationStart', '#page-upImg', function(){
        // 初始化 图片上传插件
        require.async(['../imgLoader/imageUp'], function(a){
            new a.imgUpLoader({
                inputId: 'inputImage',
                trigger: '#btn',
                fn: function(img){
                    $('.img-list > img').attr('src', img);
                }
            }).init();
        });
    });

    $(document).off('change',"#birthday input");
    $(document).on ('change',"#birthday input", function(){
        var birthday_N = $("#birthday input").val();
        if(birthday_N){
            birthday_N = parseInt(birthday_N.substring(0,4));
            var mydate = new Date();
            var new_year = parseInt(mydate.getFullYear());
            if( birthday_N && new_year ){
                var age = new_year - birthday_N;
                $("#age").val(age);
            }
        }
    });
    $("#city-picker").cityPicker({
        toolbarTemplate: '<header class="bar bar-nav" style="background-color:white">'+
                               '<button class="button button-link pull-right close-picker" style="color: #0894ec">确定</button>'+
                               '<h1 class="title">选择地址</h1>'+
                         '</header>'
    });
    // 点击我的待办
    $(document).on("click", "#my_oa", function (e) {
 
        require.async(['../oa/index', '../oa/index.css'], function(a){
            $.router.load('../oa/index.html');
        });
    });
    // 点击我的消息
    $(document).on("click", "#my_Info", function (e) {
        $.router.load('#page-my-Info', $(e.currentTarget).data('id'), true);
    });
    // 消息列表
    $(document).on("click", "#infoList .info_list", function (e) {
        infoId = $(this).attr("infoId");
        $.router.load('#page-my-Info-list', $(e.currentTarget).data('id'), true);
    });
    // 我的创意
    $(document).on('click', '#my_originality', function(e){
        require.async(['../creativityCenter/creativity', '../creativityCenter/creativity.css'], function(a){
            a.toPage({
                pageType: 'list',
                isMy    : 'Y',
                type    : 'MK_QSMX'
            }).go();
        });
    });
    // 我的方案
    $(document).on('click', '#my_programme', function(e){
        require.async(['../creativityCenter/creativity', '../creativityCenter/creativity.css'], function(a){
            a.toPage({
                pageType: 'list',
                isMy    : 'Y',
                type    : 'MK_FA'
            }).go();
        });
    });
    //点击我的头部
    $(document).on("click", ".panel-user-img img", function (e) {
        $.router.load('#page-Upmy-Info', $(e.currentTarget).data('id'), true);
    });
    //我的积分
    $(document).on("click", ".sp-score-num", function (e) {
        $.router.load('#page-my-score', $(e.currentTarget).data('id'), true);
    });
    //积分详情
    $(document).on("click", "#score_detail", function (e) {
        $.router.load('#page-score-Info', $(e.currentTarget).data('id'), true);
    });
    //积分兑换页面跳转
    $(document).on("click", "#jfdh_submit", function (e) {
        //$.router.load('../pointsMall/index.html', $(e.currentTarget).data('id'), true);

        require.async(['../pointsMall/index', '../pointsMall/pointsMall.css'], function(){
            $.router.load('../pointsMall/index.html');
        });
    });
    //众筹-我的众筹
    $(document).on("click", "#my_funding", function (e) {
        require.async(['../indiegogo/indiegogo', '../indiegogo/indiegogo.css'], function(page){
            page.pageMyIndiegogo('page-my-indiegogo');
        });
    });
    //新品试用-我的试用
    $(document).on("click", "#my_use", function (e) {
        require.async(['../indiegogo/indiegogo', '../indiegogo/indiegogo.css'], function(page){
            page.pageMyIndiegogo('page-my-tryout');
        });
    });
    //点击积分规则
    $(document).on("click", "#my_integral", function (e) {
        $.router.load('#page-point', $(e.currentTarget).data('id'), true);

    });
    //我的话题
    $(document).on("click", "#my_Topic", function (e) {
        require.async(['../topic/index', '../topic/myCommonList.css'], function(a){
            $.router.load('../topic/myCommonList.html');
        });

    });

    // 联系我们
    $(document).on("click", '#my_contact', function(){
        $.router.load('#page-contact');
    });

    // 积分排名
    $(document).on('click', '#score_range', function(){
        if(isLogin()){
            require.async(['../scoreBoard/scoreBoard.css', '../scoreBoard/index'], function(){
                $.router.load('../scoreBoard/index.html');
            });
         }
    });

    //我的收藏
    $(document).on("click", "#my_Collection", function (e) {
        $.router.load('#page-collection', $(e.currentTarget).data('id'), true);
    });
    //收藏详情-页面跳转
    $(document).on("click", ".c-content-li", function (event) {
        var isMy = $(this).parent().attr("isMy") || "N";
        var _id = $(this).parent().attr("code_id");
        var _type = $(this).parent().attr("code_type");
        var pageParam = {
            isMy     : isMy,
            pageType : "detail",
            code     : _id,
            type     : _type
        };
        require.async(['../creativityCenter/creativity','../creativityCenter/creativity.css'], function(a){
            a.toPage({
                isMy     : isMy,
                pageType : "detail",
                code     : _id,
                type     : _type
            }).go();
        });

    });
    //删除我的收藏
    $(document).on("click", ".sc_span", function (event) {

        var _id = $(this).attr("code_id");
        var _type = $(this).attr("code_type");
        deleteCollection(_id,_type);
    });
    //设置
    $(document).on("click", "#my_setUp", function (e) {
        $.router.load('#page-setUp', $(e.currentTarget).data('id'), true);
        if(myDetail.type == 'employee'){//不是内部员工隐藏
            $("#page-setUp #loginPassword_text").hide();
        }
    });
    //修改登录密码
    $(document).on("click", "#loginPassword_text", function (e) {
        $.router.load('#page-loginPassword', $(e.currentTarget).data('id'), true);
    });

    //修改密码提交事件
    $(document).on("click", "#submit", function (e) {
        submit_pass();
    });
    //保存个人信息
    $(document).on("click", "#save", function (e) {
        upMyInfo();
    });
    //退出登录
    $(document).on("click", "#signOut", function (e) {

        jomooAjax({
            apiLast: 'common/out',
            type   : 'GET', 
            success: function(data){
                if(data.status){
                    window.localStorage.clear();
                    $.alert('退出成功', function(){
                        history.go(- (history.length - 1));
                        window.location.href = '../appHome/home.html';
                    });
                } else {
                    $.toast('退出失败，请稍后再试！');
                }
            }
        });
    });
    //修改支付密码
    $(document).on("click", "#paymentPassword_text", function (e) {
        $.router.load('#page-paymentPassword', $(e.currentTarget).data('id'), true);
        $("#page-paymentPassword #code").val("");
    });
    //获取验证码
    $(document).on("click", ".zf_span", function (e) {
        var validateBtn = $(e.currentTarget),
            times = 60;
        jomooAjax({
            "apiLast": 'validate/getValidateCode',
            "success": function (data) {
                if(data.status){
                    /*切换样式，展示*/

                    validateBtn.addClass("validate-ing-code")
                        .text(times+'s').removeClass('zf_span');
                    /*开始倒计时*/
                     _setInterval = setInterval(function(){
                        times--;
                        $('.validate-ing-code').text(times+'s');
                        /*倒计时结束*/
                        if(Number(times) === 0){
                            /*清楚定时器*/
                            window.clearInterval(_setInterval);
                            /*重置样式*/
                            $('.validate-ing-code').addClass('zf_span')
                                .text('获取验证码').removeClass('validate-ing-code');
                        }
                        console.log(times+'s');
                    },1000);
                } else {
                    $.toast(data.errorMessage);
                }
            }
        });
    });
    //验证验证码
    $(document).on("click", "#nextStep", function (e) {
        var is_step = $(".validate-ing-code").text();
        if(is_step != '' && is_step != null && is_step != undefined){
            var code = $("#code").val();
            if( code == '' || code == null || code == undefined){
                $.toast("验证码不能为空");
                return;
            } else {
                /*清楚定时器*/
                window.clearInterval(_setInterval);
                /*重置样式*/
                $('.validate-ing-code').addClass('zf_span')
                    .text('获取验证码').removeClass('validate-ing-code');
                validateCode(code);
            }
        } else {
            $.toast("请获取验证码！");
            return;
        }
    });
    //设置支付密码
    $(document).on("click", "#payment-submit", function (e) {
        var pay_pass = $("#paymentPasswordVal").val();
        var pay_againpass = $("#again-paymentPasswordVal").val();
        if (!paymentPassword(pay_pass,"支付密码")) return;
        if (!paymentPassword(pay_againpass,"确认密码")) return;
        if(pay_pass == pay_againpass){
            setPassword(pay_pass);
        } else {
            $.toast("支付密码与确认密码不一致！");
            return;
        }
    });
    //上传图片
    $(document).on("click", "#img_ID", function (e) {
        $.router.load('#page-upImg', $(e.currentTarget).data('id'), true);
    });
    //保存头像图片
    $(document).on("click", "#save_img", function (e) {
        save_img =  $(".img-list img").attr("src");
        My_img = save_img;
        $.router.back();
    });
    //我的消息分页
    $(document).on("click", "#InfoMoreList", function (e) {
        p_x++;//页数+1
        InfoMoreList();
    });

    //我的收藏分页
    $(document).on("click", "#addMoreCollection", function (e) {
        p_h++;//页数+1
        addMoreCollection();
    });
    //积分规则分页
    $(document).on("click", "#addMoreItems", function (e) {
        p_j++;//页数+1
        addMoreItems();
    });
    //积分明细分页
    $(document).on("click", "#addScoreInfo", function (e) {
        p_JF++;//页数+1
        ScoreInfo();
    });


    //我的信息
    var initMyInfo = function () {
        var option = [{
            header: '我的交互',
            list: [{
                id      : 'my_oa',
                iconCls : 'icon-oa',
                iconText: '我的待办'
            },{
                id      : 'my_Info',
                iconCls : 'icon-msg',
                iconText: '我的消息'
            },{
                id      : 'my_originality',
                iconCls : 'icon-create',
                iconText: '我的创意'
            },{
                id      : 'my_programme',
                iconCls : 'icon-scheme',
                iconText: '我的方案'
            },{
                id      : 'my_use',
                iconCls : 'icon-try',
                iconText: '我的试用'
            },{
                id      : 'my_funding',
                iconCls : 'icon-indiegogo',
                iconText: '我的众筹'
            },{
                id      : 'my_Topic',
                iconCls : 'icon-topic',
                iconText: '我的话题'
            }]
        },{
            header: '常用功能',
            list: [{
                id      : 'my_integral',
                iconCls : 'icon-score',
                iconText: '积分规则'
            },{
                id      : 'my_Collection',
                iconCls : 'icon-collect',
                iconText: '我的收藏'
            },{
                id      : 'my_contact',
                iconCls : 'icon-contact',
                iconText: '联系我们'
            },{
                id      : 'score_range',
                iconCls : 'icon-range',
                iconText: '积分排行'
            },{
                id      : 'my_setUp',
                iconCls : 'icon-setting',
                iconText: '设置'
            }]
        }];

        jomooAjax({
             "apiLast": 'member/detailInfo',
             "success": function (data) {
                if(data.status){
                     myDetail = data.detail;
                    if (myDetail) {
                        var yh_name = '';
                        if (myDetail.type == 'employee') {
                            yh_name = '员工';
                        } else if (myDetail.type == 'supplier') {
                            yh_name = '供应商';
                        } else if (myDetail.type == 'crm') {
                            yh_name = '采购商';
                        } else if (myDetail.type == 'customer') {
                            yh_name = '会员';
                        }
                        if(myDetail.type !== 'employee'){//不是内部员工隐藏我的待办
                            option[0].list.splice(0,1);
                        }

                        signScore = myDetail.signScore || 0;

                        var _html = '';

                        _html += '<div class="panel-user-img">' +
                                    '<img onerror="javascript:this.src=\'../public/images/moren2.png\';" src="' + getImgUrl(myDetail.imageAddress) + '">' + 
                                 '</div>' +
                                 '<div class="panel-user-info">' + 
                                    '<span>' + myDetail.nickName + '</span>' +
                                    // '<img src="' + getImgUrl(myDetail.gradeUrl) + '" />' +
                                    '<span class="sp-grade-level">V7</span>' + '<span class="sp-grade-name">整体卫浴</span>' +
                                 '</div>' +
                                 '<div class="panel-sign-score">';
                       
                        if (myDetail.signStatus) {//ture签到
                            _html += '<span class="sp-sign" data-status="Y">已签到 <label class="my_number">+' + signScore + '</label></span>';
                        } else {
                            _html += '<span class="sp-sign" id="signing" data-status="N">签到</span>';
                        }            
                        _html += '<span class="sp-score-num" data-num="' + myDetail.totalScore +'">积分值<label>' + myDetail.totalScore + '</label></span>';
                        _html += '</div>';
                        
                        $(".user-info-profile").html(_html);
                        
                        $('.sp-sign[data-status="N"]').click(function () {
                            signing(); //签到
                        });
                    }
                    $('#type_all').html(typeListHtml(option));
                }
             }
         });
        /* 查询待办数 */
        jomooAjax({
            apiLast: 'oa/count',
            beforeSend: function(){},
            success: function (data){
                if(data.status && data.detail && data.detail.trim()){
                    $('#my_oa .icon-oa').addClass('tip-dot');
                } else {
                    $('#my_oa .icon-oa').removeClass('tip-dot');
                }
            }
        });
    };

    // 功能列表
    var typeListHtml = function(option){
        var _html = '';

        option.forEach(function(op){

            _html += '<section class="type-item">' +
                     '<h3>' + op.header + '</h3>' +
                     '<table class="type-item-table">';
            var len = op.list.length%4 ? (((op.list.length-op.list.length%4)/4 + 1) * 4) : op.list.length;

            for(var i = 0; i < op.list.length; i++){
                if(i%4 === 0) _html += '<tr>';
                _html += '<td id=' + op.list[i].id + '>' + 
                            '<i class="icon-common ' + op.list[i].iconCls + '"></i>' +
                            '<span class="icon-text">' + op.list[i].iconText + '</span>' +
                         '</td>';             
                if(i%4 === 3) _html += '</tr>';
            }
            for(var i = 0; i < len - op.list.length; i++){
                _html += '<td></td>';
            }

            _html += '</table></section>';

        });

        return _html;
    };

    //获取个人信息并显示
    var selectMyInfo = function () {

        myDetail = app.userInfo;
        
        if(myDetail){
            if(save_img){
                var img_html= '<img id="imgHead"  src="'+save_img+'" data_img="'+save_img+'" onerror="javascript:this.src=\'../public/images/moren2.png\';">';
                $("#img_ID").html(img_html);
            } else {
                var img_html= '<img id="imgHead"  src="'+getImgUrl(myDetail.imageAddress)+'" data_img="'+myDetail.imageAddress+'" onerror="javascript:this.src=\'../public/images/moren2.png\';">';
                $("#img_ID").html(img_html);
                My_img = myDetail.imageAddress;
            }

            $("#nickname").val(myDetail.nickName || '');
            $("#username").val(myDetail.userName || '');
            $("#phoneNumber").val(myDetail.phone || '');
            if(myDetail.sex == "NONE" || myDetail.sex == undefined){
                $("input[name=sex]").eq(0).attr('checked',true);
            } else {
                if(myDetail.sex == "男"){
                    $("input[name=sex]").eq(0).attr('checked',true);
                } else {
                    $("input[name=sex]").eq(1).attr('checked',true);
                }
            }

            $("#birthday input").val(myDetail.userBirth || '');
            if(myDetail.userBirth){
                var birthday_N = parseInt(myDetail.userBirth.substring(0,4));
                var mydate = new Date();
                var new_year = parseInt(mydate.getFullYear());
                if( birthday_N && new_year ){
                    var age = new_year - birthday_N;
                    $("#age").val(age);
                }
            } else {
                $("#age").val(0);
            }
            $("#address").val(myDetail.address || '');
            
            if(myDetail.city) {
                myDetail.city === myDetail.province ? $('#city-picker').val(myDetail.city     + ' ' + myDetail.county)
                                                    : $('#city-picker').val(myDetail.province + ' ' + myDetail.city + ' ' + myDetail.county);
            }
            
            $("#occupation").val(myDetail.profession || '');
        }
    };

    //修改个人信息
    var upMyInfo = function () {
        var ingHead    = $("#imgHead").attr("data_img"), 
            nickname   = $("#nickname").val(), 
            username   = $("#username").val(), 
            phoneNumber= $("#phoneNumber").val(), 
            sex        = $('#sex_div input[name="sex"]:checked ').attr("data_val"), 
            age        = $("#age").val(), 
            userBirth  = $("#birthday input").val(), 
            city       = $('#city-picker').val(), 
            address    = $("#address").val(), 
            occupation = $("#occupation").val(),
            _pcc;

        if(nickname == '' || nickname == null || nickname == undefined){
            $.alert("昵称不能为空！");
            return;
        }
        if(nickname == '九牧官方') {
            $.alert("昵称不能为九牧官方！");
            return;
        }
        if(username == '' || username == null || username == undefined){
            $.alert("姓名不能为空！");
            return;
        }
        if(userBirth == '' || userBirth == null || userBirth == undefined){
            $.alert("出生日期不能为空!");
            return;
        }
        if(!city.trim()) {
            $.alert('请选择所在地区！');
            return;
        } else {
            _pcc = city.trim().split(' ');
            if(_pcc.length === 2) _pcc = [].concat(_pcc[0], _pcc);
        }
        if(address == '' || address == null || address == undefined){
            $.alert("详细地址不能为空!");
            return;
        }
        if(occupation == '' || occupation == null || occupation == undefined){
            $.alert("职业不能为空!");
            return;
        }
        var _param = {
                      imageAddress: ingHead,
                      nickName    : nickname,
                      userName    : username,
                      phone       : phoneNumber,
                      sex         : sex,
                      age         : age,
                      userBirth   : userBirth,
                      province    : _pcc[0],
                      city        : _pcc[1],
                      county      : _pcc[2],
                      address     : address,
                      profession  : occupation
                  };
        jomooAjax({
            "apiLast": 'member/updateInfo',
            "params" : _param,
            "success": function (data) {
                if(data.status){
                    $.alert(data.detail, '', function () {
                        jomooAjax({
                            "apiLast": 'member/detailInfo',
                            "success": function (datas) {
                                if (datas.status) {
                                    // 更新本地个人信息
                                    //save_img = '';
                                    _param.imageAddress = datas.detail.imageAddress;
                                    $.extend(app.userInfo, _param);
                                    window.localStorage.setItem('userInfo', JSON.stringify(app.userInfo));
                                    $.router.back();
                                }
                            }
                        });


                    });
                } else {
                    $.toast(data.errorMessage);
                    return;
                }
            }
        });
    };

    //签到
    var signing =function () {
        jomooAjax({
            "apiLast": 'member/sign',
            "success": function (data) {
                if(data.status){
                    $('.sp-sign').html('已签到 <label class="my_number">+' + signScore + '</label>').attr('data-status', 'Y');
                    initMyInfo();
                } else {
                    $.toast(data.detail);
                    return;
                }
            }
        });
    };

    //积分详情
    var selectScoreInfo = function () {
        jomooAjax({
            "apiLast": 'score/detailList',
            "params": {p:p_JF,s:s_JF},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        for(var i=0;i<data.length;i++){
                            _html += '<div class="info_list jfmx_list">';
                            _html += '<p class="my_need new_color" style="width: 80%">'+data[i].date+'</p><span class="span_c" style="color:#ff9425;">'+data[i].score+'</span>';
                            _html +=    '<p class="my_need " style="width: 80%;margin-top: 5px;">'+data[i].name+'</p>';
                            _html += '</div>';
                        }
                        if(data.length == s_JF) {
                            _html += ' <div class="load-more" id="addScoreInfo"><span>查看更多</span></div>';
                        }
                        $("#page-score-Info #scoreList").html(_html);
                    } else {
                        if(p_JF == 0) {
                            baseInfo.nodata(".queSurvey-list");
                        }

                    }
                }
            }
        });
    };

    var ScoreInfo = function () {
        $(".load-more").remove();
        jomooAjax({
            "apiLast": 'score/detailList',
            "params": {p:p_JF,s:s_JF},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        for(var i=0;i<data.length;i++){
                            _html += '<div class="info_list jfmx_list">';
                            _html += '<p class="my_need new_color" style="width: 80%">'+data[i].date+'</p><span class="span_c" style="color:#ff9425;">'+data[i].score+'</span>';
                            _html +=    '<p class="my_need " style="width: 80%;margin-top: 5px;">'+data[i].name+'</p>';
                            _html += '</div>';
                        }
                        if(data.length == s_JF) {
                            _html += ' <div class="load-more" id="addScoreInfo"><span>查看更多</span></div>';
                        }
                        $("#page-score-Info #scoreList").append(_html);
                    }
                }
            }
        });
    };

    //我的消息接口
    var selectInfo = function () {
        jomooAjax({
            "apiLast": 'global/sysmessage/list',
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var _html = '';
                        var red_html = '';
                        data = data.list;
                        for(var i=0;i<data.length;i++){
                            if(data[i].pushStatus == "N"){ //N未读，R已读
                                red_html = '<span class="red_class red_col"></span>';
                            } else {
                                red_html = '<span class="red_class"></span>';
                            }
                            _html += '<div class="info_list icon-arrow '+data[i].messageType+'" infoId="'+data[i].messageType+'">';
                            _html +=    red_html+'<p class="my_need">'+data[i].messageTypeName+'<span class="span_c new_color">'+data[i].createDate+'</span></p>';
                            _html +=    '<p class="my_need new_color">'+data[i].content+'</p>';
                            _html += '</div>';
                        }
                        $("#page-my-Info #infoList").html(_html);
                    }else {
                        baseInfo.nodata("#page-my-Info #infoList");
                    }
                }
            }
        });
    };

    //我的收藏
    var selectCollection = function () {
        p_h = 0;
        jomooAjax({
            "apiLast": 'crowd/collectionList',
            "params": {p:p_h,s:s_h},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var html_ = '';
                        data = data.list;
                        for(var i=0;i<data.length;i++){
                            html_ += ' <ul class="c-content" code_id="'+data[i].code+'" code_type="'+data[i].type+'" isMy="'+data[i].isMy+'">'+
                            '<li class="c-content-li li-first"><img class="li-img" onerror="javascript:this.src=\'../public/images/moren1.png\';" src="'+getImgUrl(data[i].imgUrl)+'" alt=""/></li>'+
                            '<li class="c-content-li li-title single-row">'+data[i].title+'</li>'+
                            '<li class="c-content-li li-description single-row" style="top: 35px;">'+data[i].description+'</li>'+
                            '<li class="c-content-li li-author single-row" style="top: 60px;">'+data[i].createName+'<span style="margin-left: 10px">'+data[i].createDate+'</span></li>'+
                                '<span class="sc_span" code_id="'+data[i].code+'" code_type="'+data[i].type+'"></span>'+
                            '</ul>';
                        }
                        if(data.length == s_h){
                            html_ += ' <div class="load-more" id="addMoreCollection"><span>查看更多</span></div>';

                        }
                        $('#collectionList').html(html_);
                    } else {
                        if(p_h == 0)
                        baseInfo.nodata('#collectionList');
                    }
                }
            }
        });
    };

    var addMoreCollection = function () {
        $(".load-more").remove();
        jomooAjax({
            "apiLast": 'crowd/collectionList',
            "params": {p:p_h,s:s_h},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var html_ = '';
                        data = data.list;
                        for(var i=0;i<data.length;i++){
                            html_ += ' <ul class="c-content" code_id="'+data[i].code+'" code_type="'+data[i].type+'" isMy="'+data[i].isMy+'">'+
                            '<li class="c-content-li li-first"><img class="li-img" onerror="javascript:this.src=\'../public/images/moren1.png\';" src="'+getImgUrl(data[i].imgUrl)+'" alt=""/></li>'+
                            '<li class="c-content-li li-title single-row">'+data[i].title+'</li>'+
                            '<li class="c-content-li li-description single-row" style="top: 35px;">'+data[i].description+'</li>'+
                            '<li class="c-content-li li-author single-row" style="top: 60px;">'+data[i].createName+'<span style="margin-left: 10px">'+data[i].createDate+'</span></li>'+
                            '<span class="sc_span" code_id="'+data[i].code+'" code_type="'+data[i].type+'"></span>'+
                            '</ul>';
                        }
                        if(data.length == s_h){
                            html_ += ' <div class="load-more" id="addMoreCollection"><span>查看更多</span></div>';
                        }
                        $('#collectionList').append(html_);
                    }
                }
            }
        });
    };

    //删除我的收藏
    var deleteCollection = function (_code,_type) {
        jomooAjax({
            "apiLast": 'crowd/deleteCollection',
            "params": {code:_code,type:_type},
            "success": function (data) {
                if(data.status){
                    $.toast("删除成功！");
                    $("#collectionList .c-content[code_id='"+_code+"']").remove();
                    if(!$("#collectionList").hasClass('c-content')){
                        baseInfo.nodata("#collectionList");
                    }
                } else {
                    $.toast(data.errorMessage);
                    return;
                }
            }
        });
    };

    //我的消息列表接口
    var selectInfoList = function (){
        p_x = 0 ;
        jomooAjax({
            "apiLast": 'global/sysmessage/detail',
            "params": {messageType: infoId,p:p_x,s:s_x},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        data = data.list;
                        var html = '';
                        for (var i = 0; i < data.length; i++) {
                            html += '<div class="project-process-card">';
                            html += '<i class="project-process-line"></i>';
                            html += '<span class="left-date">' + data[i].createDate + '</span>';
                            html += '<span class="left-arrow"></span>';
                            html += '<span class="left-arrow-cover"></span>';
                            html += '<p class="right-content">' + data[i].content + '</p>';
                            html += '</div>';
                        }
                        if(data.length == s_x){
                            html += ' <div class="load-more" id="InfoMoreList"><span>查看更多</span></div>';
                        }
                        $('.card-container').html(html);

                    } else {
                        if( p_x == 0 ){
                            baseInfo.nodata('.card-container');
                        }

                    }
                }
            }
        });
    };

    var InfoMoreList = function (){
        $(".load-more").remove();
        jomooAjax({
            "apiLast": 'global/sysmessage/detail',
            "params": {messageType: infoId,p:p_x,s:s_x},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        data = data.list;
                        var html = '';
                        for (var i = 0; i < data.length; i++) {
                            html += '<div class="project-process-card">';
                            html += '<i class="project-process-line"></i>';
                            html += '<span class="left-date">' + data[i].createDate + '</span>';
                            html += '<span class="left-arrow"></span>';
                            html += '<span class="left-arrow-cover"></span>';
                            html += '<p class="right-content">' + data[i].content + '</p>';
                            html += '</div>';
                        }
                        if(data.length == s_x){
                            html += ' <div class="load-more" id="InfoMoreList"><span>查看更多</span></div>';
                        }
                        $('.card-container').append(html);
                    }
                }
            }
        });
    };

    //排行榜列表/*加载更多*/
    var addItems = function () {
        p_j =0;
        jomooAjax({
            "apiLast": 'score/rule',
            "params": {p:p_j,s:s_j},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        var score_val='';
                        var count_val ='';
                        for(var i=0;i<data.length;i++){
                            _html += '<tr>';
                            _html += '<td>' + data[i].name + '</td>';
                            score_val='';
                            if(data[i].singleFlag == 'Y'){
                                score_val = data[i].score;
                            }else {
                                score_val = data[i].averageScore +'-'+data[i].excellentScore;
                            }
                            _html += '<td style="color: #ff8506">' + score_val + '</td>';
                            count_val = ''
                            if(data[i].count == '0'){
                                count_val = '首次';
                            } else if (data[i].count == '-1') {
                                count_val = '不限次数';
                            } else {
                                count_val = data[i].count+'次';
                            }
                            _html += '<td style="color: #9E9E9E">' + count_val + '</td>';
                            _html += '</tr>';
                        }
                        if(data.length == s_j){
                            $(".load-more").show();
                        } else {
                            $(".load-more").hide();
                        }
                        $(".score-rule-table tbody").html(_html);
                    } else {
                        if(p_j == 0){
                            baseInfo.nodata(".score-rule-table tbody");
                        }

                    }
                }
            }
        });
    };

    var addMoreItems = function () {
        $(".load-more").hide();
        jomooAjax({
            "apiLast": 'score/rule',
            "params": {p:p_j,s:s_j},
            "success": function (data) {
                if(data.status){
                    if (data.list.length > 0) {
                        var _html = '';
                        data = data.list;
                        var score_val='';
                        var count_val = '';
                        for(var i=0;i<data.length;i++){
                            _html += '<tr>';
                            _html += '<td>' + data[i].name + '</td>';
                            score_val='';
                            if(data[i].singleFlag == 'Y'){
                                score_val = data[i].score;
                            }else {
                                score_val = data[i].averageScore +'-'+data[i].excellentScore;
                            }
                            _html += '<td style="color: #ff8506">' + score_val + '</td>';
                            count_val = ''
                            if(data[i].count == '0'){
                                count_val = '首次';
                            } else if (data[i].count == '-1') {
                                count_val = '不限次数';
                            } else {
                                count_val = data[i].count+'次';
                            }
                            _html += '<td style="color: #9E9E9E">' + count_val + '</td>';

                            _html += '</tr>';
                        }
                        if(data.length == s_j){
                            $(".load-more").show();
                        }
                        $(".score-rule-table tbody").append(_html);
                    }
                }
            }
        });
    };

    //修改密码提交接口
    var submit_pass = function () {
        var oldPassword = $("#oldPassword").val();
        var newPassword = $("#newPassword").val();
        var againPassword = $("#againPassword").val();
        if(oldPassword == '' || oldPassword == null || oldPassword == undefined) {
            $.toast('旧密码不能为空！');
            return;
        }
        /*if( newPassword == '' || newPassword == null || newPassword == undefined) {
            $.toast('新密码不能为空！');
            return;
        }*/
        /*密码校验*/
        if (!validatePassword(newPassword)) return;
        if( againPassword == '' || againPassword == null || againPassword == undefined) {
            $.toast('确认密码不能为空！');
            return;
        }
        if (newPassword != againPassword){
            $.toast('新密码与确认密码不相同！');
            return;
        }
        jomooAjax({
            "apiLast": 'member/updatePassword',
            "params": {oldPassword:oldPassword,newPassword:newPassword},
            "success": function (data) {
                if(data.status){
                    $.alert(data.detail, '', function () {
                        // history.go(-2);
                        // require.async(['../login/login', '../login/login.css'], function(){
                        //     $.router.load('../login/login.html');
                        // })
                        app.back('page-point-list');// 修改成功 回到 我的 页面
                    });
                } else {
                    $.alert(data.errorMessage, '', function () {
                        $("#oldPassword").val("");
                        $("#newPassword").val("");
                        $("#againPassword").val("");
                        $.router.back();
                    });
                }
            }
        });
    };

    /*验证密码*/
    var validatePassword = function (ele) {
        var  password = ele
            , flag = false;
        if (password == 0) {
            $.toast("密码不能为空！");
        } else if (password.length < 6) {
            $.toast("密码长度不少于6位！");
        } else if (password.length > 22) {
            $.toast("密码长度不多于22位！");
        } else if (!password.match(/^(?=.*[a-zA-Z])(?=.*[0-9])[a-zA-Z0-9]{6,22}$/)) {
            $.toast("密码为字母和数字的组合！");
        } else {
            flag = true;
        }
        return flag;
    };

    /*验证密码*/
    var paymentPassword = function (ele,text) {
        var  password = ele
            , flag = false;
        if (password == 0) {
            $.toast(text+"不能为空！");
        } else if (password.length != 6) {
            $.toast("请输入6位数字的"+text+"！");
        } else if (!password.match(/^[0-9]*$/)) {
            $.toast(text+"只能是数字！");
        } else {
            flag = true;
        }
        return flag;
    };

    //验证验证码
    var validateCode = function (code) {
        jomooAjax({
            "apiLast": 'validate/validateCode',
            "params": {"code":code},
            "success": function (data) {
                if(data.status){
                    $.router.load('#page-paymentPassword-val', '', true);
                    $("#page-paymentPassword-val #paymentPasswordVal").val("");
                    $("#page-paymentPassword-val #again-paymentPasswordVal").val("");

                } else {
                    $.toast(data.errorMessage);
                }
            }
        });
    };

    //设置支付密码
    var setPassword = function (num) {
        jomooAjax({
            "apiLast": 'validate/setPassword',
            "params": {"password":hex_md5(num)},
            "success": function (data) {
                if(data.status){
                    $.alert(data.detail, '', function () {
                        history.go(-2);
                    });
                } else {
                    $.alert(data.errorMessage, '', function () {
                        history.go(-2);
                    });
                }
            }
        });
    };
});
});