﻿define(function(require, exports, module){
    require('../public/js/md5.js');

    $(function () {

    var p = 0 ,
        s = 5 ,
        totalScore,
        point = '',
        phones= '',
        gift  = '',
        worth = '',
        score = '',
        applyParam = {}; // 积分兑换礼品申请参数

    $(document).on("pageInit", ".page", function (e, id, page) {
        switch(id){
            case 'page-point-list'    : myScore();
            break;
            case 'page-exchange-list' : addItems();
            break;
            case 'page-confirm-bill'  : getBillHtml();
            break;
            case 'page-confirm-rebate': $('.ablePoint').text(point + "分");
                                        getRedate();
            break;
            case 'page-point-charge'  : mallList();
            break;
        }
    });

    //列表分页
    $(document).on("click", "#addMoreList", function (e) {
        p++;//页数+1
        addMoreItems();
    });


    // 详情
    $(document).on('click', '.mall-list li', function(e){
        var $e = $(e.currentTarget);
        var detailInfo, employeeInfo, successFlag = 0;
        jomooAjax({
            apiLast: 'mall/detail',
            params : {
                id : $e.data('id')
            },
            success: function(data){
                detailInfo = data.list[0];
                successFlag++;
            }
        });
        jomooAjax({
            apiLast: 'product/employees',
            success: function(data){
                employeeInfo = data.list[0];
                successFlag++;
            }
        });
        helper.once(function(){
            return successFlag > 1;
        }, function(){
            mallApply(detailInfo, employeeInfo);
            $.router.load('#page-charge-apply');
        }, 30000);
    });




    // 提交申请
    $('#page-charge-apply').on('click', '.btn-apply', function(){
        var $page = $('#page-charge-apply'),
            addressArr = $page.find('#city-picker-gift').val().trim().split(' ');
        if(addressArr.length === 1) {
            $.alert('请输入所在地区！');
            return;
        } else if(addressArr.length === 2){
            applyParam.provinceName = addressArr[0];
            applyParam.cityName     = addressArr[0] + '市';
            applyParam.countyName   = addressArr[1];
        } else if(addressArr.length === 3){
            applyParam.provinceName = addressArr[0] + '省';
            applyParam.cityName     = addressArr[1] + '市';
            applyParam.countyName   = addressArr[2];         
        }

        applyParam.remark = $page.find('.mark-area > textarea').val().trim();

        jomooAjax({
            apiLast: 'mall/save',
            params : applyParam,
            success: function(data){
                if(data.status){
                    $.alert('提交申请成功！', function(){
                        $.router.back();
                    });
                }
            }
        });
    });

    /*获取我的积分*/
    var myScore = function () {
        jomooAjax({
            "apiLast": 'score/myScore',
            "success": function (data) {
                if(data.status){
                    point = parseInt(data.detail.useableScore);
                    phones = data.detail.phone;
                    totalScore = data.detail.totalScore;
                    $('#myPoint').text(point);
                    $('#myAllPoint').text(totalScore);
                } else {
                    $.toast(data.errorMessage);
                }
            }
        });
    };

    /*兑换记录*/
    var addItems = function () {
        p = 0;
        jomooAjax({
            "apiLast": 'exchange/list',
            "params":{p:p,s:s},
            "success": function (data) {
                if(!data || !data.status) return;
                data = data.list;
                if(data.length>0){
                    var _html='';
                    for(var i=0;i<data.length;i++) {
                        var _class = '';
                        if (data[i].status == '处理中') {
                            _class = 'yellow';
                        } else if (data[i].status == '已完成') {
                            _class = 'green';
                        } else if (data[i].status == '处理失败') {
                            _class = 'red';
                        }
                        _html += '<li>';
                        _html += '<p class="ep gray">';
                        _html += '<span class="ep-date">' + data[i].createDate + '</span><span class="ep-code">&nbsp;</span>';
                        _html += '</p>';
                        _html += '<div class="ediv">';
                        _html += '<p>' + data[i].gift + '</p>';
                        _html += '<p>兑换编码：' + data[i].code + '</p>';
                        _html += '<p><span class="gray">状态：</span><span class=' + _class + '>' + data[i].status + '</span></p>';
                        _html += '</div>';
                        _html += '</li>';
                    }
                    if(data.length == s){
                        _html += ' <div class="load-more" id="addMoreList"><span>查看更多</span></div>';
                    }
                    $("#page-exchange-list .exchange ul").html(_html);
                } else {
                    if(p == 0) {
                        baseInfo.nodata("#page-exchange-list .exchange ul");
                    }
                }

            }
        });
    };
    var addMoreItems = function () {
        $(".load-more").remove();
        jomooAjax({
            "apiLast": 'exchange/list',
            "params":{p:p,s:s},
            "success": function (data) {
                if(!data || !data.status) return;
                data = data.list;
                if(data.length>0){
                    var _html='';
                    for(var i=0;i<data.length;i++) {
                        var _class = '';
                        if (data[i].status == '处理中') {
                            _class = 'yellow';
                        } else if (data[i].status == '已完成') {
                            _class = 'green';
                        } else if (data[i].status == '处理失败') {
                            _class = 'red';
                        }
                        _html += '<li>';
                        _html += '<p class="ep gray">';
                        _html += '<span class="ep-date">' + data[i].createDate + '</span><span class="ep-code">&nbsp;</span>';
                        _html += '</p>';
                        _html += '<div class="ediv">';
                        _html += '<p>' + data[i].gift + '</p>';
                        _html += '<p>兑换编码：' + data[i].code + '</p>';
                        _html += '<p><span class="gray">状态：</span><span class=' + _class + '>' + data[i].status + '</span></p>';
                        _html += '</div>';
                        _html += '</li>';
                    }
                    if(data.length == s){
                        _html += ' <div class="load-more" id="addMoreList"><span>查看更多</span></div>';
                    }
                    $("#page-exchange-list .exchange ul").append(_html);
                }
            }
        });
    };

    /*确认兑换-话费*/
    var getBillHtml = function () {
        jomooAjax({
            "apiLast": 'exchange/configList',
            "success": function (data) {
                if(!data || !data.status) return;
                $("#phoneNumber").val(showPhone(phones));
                var useScore = data.list[0].useScore;
                    var _html='';
                    var _class = '';
                    if (!checkPhone(phones)) {
                        _class = 'disableCss';
                    }
                    _html += '<p class="gray firstMargin"></p>';
                        /*_html += '<ul>';
                        for(var i=0;i<data.length;i++) {
                            _html += '<li class="unsel ' + (i % 3 == 0 ? 'firstMargin ' : '') + _class + '" data-id="' + data[i].code + '">';
                            _html += '<p class="useWorth" worth="'+data[i].worth+'" gift="'+data[i].name+'">' + data[i].worth + '元</p>';
                            _html += '<p><span class="usePoint" point="' + data[i].useScore + '">消耗积分' + data[i].useScore + '</span></p>';
                            _html += '</li>';
                        }
                        _html += '</ul>'*/

                       _html += '<ul>' +
                                    '<li class="unsel ' + _class + '" data-id="JM_DH_CZ">' +
                                        '<p class="useWorth" worth="10" gift="10元话费充值">10元</p>' +
                                        '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*10)+'">消耗积分'+parseInt(useScore*10)+'</span>' +
                                        '</p>' +
                                    '</li>' +
                                    '<li class="unsel ' + _class + '" data-id="JM_DH_CZ">' +
                                        '<p class="useWorth" worth="20" gift="20元话费充值">20元</p>' +
                                        '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*20)+'">消耗积分'+parseInt(useScore*20)+'</span>' +
                                        '</p>' +
                                    '</li>' +
                                    '<li class="unsel ' + _class + '" data-id="JD_DH_CZ50">' +
                                        '<p class="useWorth" worth="30" gift="30元话费充值">30元</p>' +
                                        '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*30)+'">消耗积分'+parseInt(useScore*30)+'</span>' +
                                        '</p>' +
                                    '</li>' +
                                    '<li class="unsel  ' + _class + '" data-id="JD_DH_CZ50">' +
                                        '<p class="useWorth" worth="50" gift="50元话费充值">50元</p>' +
                                        '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*50)+'">消耗积分'+parseInt(useScore*50)+'</span>' +
                                        '</p>' +
                                    '</li>' +
                                    '<li class="unsel ' + _class + '" data-id="JM_DH_CZ100">' +
                                        '<p class="useWorth" worth="100" gift="100元话费充值">100元</p>' +
                                        '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*100)+'">消耗积分'+parseInt(useScore*100)+'</span>' +
                                        '</p>' +
                                    '</li>' +
                                   '<li class="unsel ' + _class + '" data-id="JM_DH_CZ100">' +
                                       '<p class="useWorth" worth="300" gift="300元话费充值">300元</p>' +
                                       '<p>' +
                                            '<span class="usePoint" point="'+parseInt(useScore*3000)+'">消耗积分'+parseInt(useScore*300)+'</span>' +
                                       '</p>' +
                                   '</li>' +
                                '</ul>';
                        _html += '<p class="errorMsg firstMargin"><span>手机号码有误</span></p>';
                        $(".bill-lists").html(_html);

                }

        });
    };
    /*九牧商城抵扣卷*/
    var getRedate = function () {
        jomooAjax({
            "apiLast": 'exchange/configList',
            "params":{exchangeType:"JM_SC",p:0,s:10},
            "success": function (data) {
                if(!data || !data.status) return;
                data = data.list;
                if(data.length>0){
                    worth = data[0].worth;
                    score = data[0].useScore;
                    gift = "商城兑换券"//data[0].name;
                    var point_html = "("+data[0].useScore+"积分="+data[0].worth+"元抵扣券)";
                    $(".gray").text(point_html);

                }

            }
        });
    };
    /*验证手机号*/
    var checkPhone = function (phone) {
        phone = phone.replace(/\s/g, "");
        var result = true;
        //验证手机号
        var myreg = /^[1][3578][0-9]{9}$/;
        //$.trim(phone) != '' && 
        if (!myreg.test(phone)) {
            result = false;
        }
        if (!result && phone.length == 11) {
            $(".errorMsg").show();
        } else {
            $(".errorMsg").hide();
        }
        return result;
    };
    /*显示手机号*/
    var showPhone = function (phone) {
        var currentVal = phone.replace(/\s/g, "");
        var firstVal = ''
            , secondVal = ''
            , thirdVal = ''
            , valLen = currentVal.length;

        if (valLen > 3) {
            firstVal = currentVal.substr(0, 3) + ' ';
            if (valLen <= 7) {
                secondVal = currentVal.substr(3, valLen - 3);
            } else {
                secondVal = currentVal.substr(3, 4) + ' ';
                thirdVal = currentVal.substr(7, valLen - 7)
                if (valLen > 11) {
                    thirdVal = currentVal.substr(7, 4);
                }
            }
        } else {
            firstVal = currentVal.substr(0, valLen);
        }
        return firstVal + secondVal + thirdVal;
    };

    /* 积分礼品兑换列表 */
    var mallList = function(){
        jomooAjax({
            apiLast: 'mall/list',
            params : {p:0,s:10},
            success: function(data){
                data = data.list;
                if(data.length){
                    var _html = '';
                    _html += '<ul class="mall-list">';

                    for(var i = 0; i < data.length; i++){
                        _html += '<li data-id="' + data[i].id + '">' +
                                    '<img src="' + baseInfo.imgUrl + data[0].url + '" alt="" />' +
                                    '<p class="pz-title">' + data[0].title + '</p>' +
                                    '<p class="score">积分：<span>' + data[0].score + '</span></p>' +
                                 '</li>';
                    }

                    _html += '</ul>';
                    $('#page-point-charge .content').html(_html);
                } else {
                    baseInfo.nodata($('#page-point-charge .content'));
                }
            }
        });
    };

    /* 积分礼品兑换申请页 */
    var mallApply = function (detailInfo, employeeInfo) {
        var html = '';
        html += '<div class="gift-info-img"><img src="' + baseInfo.imgUrl + detailInfo.url + '" alt=""/></div>';
        html += '<div class="gift-info-title"><p>' + detailInfo.title + '</p><p>' + detailInfo.description + '</p><p>积分：<span style="color: #E28600;">' + detailInfo.score + '</span></p></div>';
        html += '<div class="ipt-container-layout">';
        html += '<p><span>姓名</span><input type="text" data-key="ipt-name" data-name="姓名" placeholder="请填写姓名" value="'+employeeInfo.name+'"/></p>';
        html += '<p><span>手机号</span><input type="tel" data-key="ipt-phone" data-name="手机号" placeholder="请填写手机号" value="'+employeeInfo.phone+'"/></p>';
        html += '<p><span>所在地区</span><input readonly  type="text" id="city-picker-gift" class="choose-province-span" value="'+(employeeInfo.provinceName||'')+' '+(employeeInfo.cityName||'')+' '+(employeeInfo.cityName||'')+'"/></p>';
        html += '<p class="ipt-address-indiegogo"><span>地址</span><input class="single-ipt" type="text" placeholder="请填写收货地址" value="'+employeeInfo.address+'"/></p>';
        html += '<p class="mark-area"><span>备注</span><textarea data-key="ipt-remark" placeholder="请填写备注"></textarea></p>';
        html += '</div>';

        html += '<div class="btn-bottom-layout"><span class="btn-apply">提交申请</span></div>';
        

        applyParam.giftId    = detailInfo.id;
        applyParam.giftTitle = detailInfo.title;
        applyParam.sap       = detailInfo.sap;
        applyParam.score     = detailInfo.score;
        applyParam.loginName = employeeInfo.loginName;
        applyParam.userName  = employeeInfo.name;
        applyParam.phone     = employeeInfo.phone;
        applyParam.provinceName = employeeInfo.provinceName;
        applyParam.cityName     = employeeInfo.cityName;
        applyParam.countyName   = employeeInfo.countyName;
        applyParam.address      = employeeInfo.address;

        $('#page-charge-apply .content').html(html);


        $("#city-picker-gift").cityPicker({
            toolbarTemplate: '<header class="bar bar-nav" style="background-color:white">' +
                '<button class="button button-link pull-right close-picker" style="color: #0894ec">确定</button>' +
                '<h1 class="title">选择地址</h1>' +
                '</header>'
        });

    };

    /*手机号输入事件*/
    $(document).on('input oninput change','#phoneNumber', function () {
        var phone = showPhone($(this).val());
        $(this).val(phone);

        var billList = $('.bill-lists li');
        if (!checkPhone(phone)) {
            if (billList.length > 0 && billList.eq(0).attr('class').indexOf('disableCss') == -1) {
                billList.addClass('disableCss');
            }
        } else {
            billList.removeClass('disableCss');
        }
    });

    /*选择话费点击事件*/
    $(".bill-lists li").live("click", function () {
        if ($(this).attr('class').indexOf('disableCss') == -1) {
            $(".unsel").removeClass("selected");
            $(this).toggleClass("selected");
            var _content = parseInt($(this).find('.usePoint').attr("point"));
            if(_content > point){
                $.toast('积分不足！');
                return;
            } else {
                gift = $(this).find('.useWorth').attr("gift");
                worth = $(this).find('.useWorth').attr("worth");
                score = _content;
                $.confirm('确认兑换充值吗？',
                    function () {
                        $.modal({
                            title: '<span class="close"></span><span class="please">请输入支付密码</span>',
                            text: '<div>' +
                            '<span>兑换充值</span>' +
                            '<p>' + _content + '积分</p>' +
                            '<div class="pwd-box">' +
                                '<input type="tel" maxlength="6" class="pwd-input" id="pwd-input">'+
                                '<div class=" fake-box" >'+
                                    '<input class="fake-box-input" id="num1" type="password" readonly="" >' +
                                    '<input class="fake-box-input" id="num2"  type="password" readonly="" >' +
                                    '<input class="fake-box-input" id="num3"  type="password" readonly="">' +
                                    '<input class="fake-box-input" id="num4"  type="password" readonly="">' +
                                    '<input class="fake-box-input" id="num5"  type="password" readonly="">' +
                                    '<input class="fake-box-input" id="num6" type="password" readonly="">' +
                                '</div>' +
                            '</div>'+
                            '<a style="font-size: 14px;line-height: 40px;" class="up_password">设置支付密码</a>' +
                            '</div>',
                            extraClass: 'inputPwd'
                        });
                        //密码触发事件

                        var $input = $(".fake-box input");
                        $("#pwd-input").on("input", function() {
                            var pwd = $(this).val();
                            for (var i = 0, len = pwd.length; i < len; i++) {
                                $input.eq("" + i + "").val(pwd[i]);
                            }
                            $input.each(function() {
                                var index = $(this).index();
                                if (index >= len) {
                                    $(this).val("");
                                }
                            });
                            if (len == 6) {
                                //执行其他操作
                                var sPhone = $("#phoneNumber").val();
                                sPhone = sPhone.replace(/\s+/g, "");
                                var passVal = $("#num1").val()+$("#num2").val()+$("#num3").val()+$("#num4").val()+$("#num5").val()+$("#num6").val();
                                exchange("JM_CZ",hex_md5(passVal),sPhone);
                            }
                        });
                        $('.up_password').click(function(){
                            $.closeModal(".modal");
                            require.async(['../myInfo/index', '../myInfo/pointsMall.css'], function(){
                                $.router.load('../myInfo/index.html?#page-paymentPassword');
                            });
                        });
                    },
                    function () {

                    }
                );

            }


        }
    });
    
    /*抵扣卷兑换*/
    $("#page-confirm-rebate .rebateok").live("click", function () {
        var phones = $("#rebatePhone").val();

        if(phones == '' || phones == null || phones ==undefined){
            $.toast('手机号码为空或者格式不正确！');
            return ;
        }
        //验证手机号
        var myreg = /^[1][3578][0-9]{9}$/;
        if (!myreg.test(phones)) {
            $.toast('手机号码为空或者格式不正确！');
            return ;
        }
        phones = phones.replace(/\s+/g, "");
        var money = $("#rebateMoney").val();

        if(money == '' || money == null || money ==undefined){
            $.toast('金额为空或者格式不正确！');
            return ;
        }
        var money_test = /^\+?[1-9][0-9]*$/;
        if (!money_test.test(money)) {
            $.toast('金额为空或者格式不正确！');
            return ;
        }
        //计算一块钱需要多少积分
        var scoreOne = score/worth;
        var scoreAll = scoreOne*parseInt(money);
        if(scoreAll > point){
            $.toast('积分不足！');
            return;
        }
        $.confirm('确认兑换抵扣卷吗？',
            function () {
                $.modal({
                    title: '<span class="close"></span><span class="please">请输入支付密码</span>',
                    text: '<div>' +
                    '<span>兑换抵扣卷</span>' +
                    '<p>共消耗' + scoreAll + '积分</p>' +
                    '<div class="pwd-box">' +
                        '<input type="tel" maxlength="6" class="pwd-input" id="pwd-input">'+
                        '<div class=" fake-box" >'+
                            '<input class="fake-box-input" id="pnum1" type="password" readonly="" >' +
                            '<input class="fake-box-input" id="pnum2"  type="password" readonly="" >' +
                            '<input class="fake-box-input" id="pnum3"  type="password" readonly="">' +
                            '<input class="fake-box-input" id="pnum4"  type="password" readonly="">' +
                            '<input class="fake-box-input" id="pnum5"  type="password" readonly="">' +
                            '<input class="fake-box-input" id="pnum6" type="password" readonly="">' +
                        '</div>' +
                    '</div>'+
                    '<a style="font-size: 14px;line-height: 40px;" class="up_password">设置支付密码</a>' +
                    /*'<p class="pwdp_hide"></p>'+*/
                    '</div>',
                    extraClass: 'inputPwd'
                });
                //密码触发事件
                var $input = $(".fake-box input");
                $("#pwd-input").on("input", function() {
                    var pwd = $(this).val();
                    for (var i = 0, len = pwd.length; i < len; i++) {
                        $input.eq("" + i + "").val(pwd[i]);
                    }
                    $input.each(function() {
                        var index = $(this).index();
                        if (index >= len) {
                            $(this).val("");
                        }
                    });
                    if (len == 6) {
                        //执行其他操作
                        var passVal = $("#pnum1").val()+$("#pnum2").val()+$("#pnum3").val()+$("#pnum4").val()+$("#pnum5").val()+$("#pnum6").val();
                        try{
                            var passVals = hex_md5(passVal);
                        }catch(e){
                        }
                        worth = money;
                        score = scoreAll;
                       exchange("JM_SC",passVals,phones);

                    }
                });
                $('.up_password').click(function(){
                    $.closeModal(".modal");
                    require.async(['../myInfo/index', '../myInfo/pointsMall.css'], function(){
                        $.router.load('../myInfo/index.html?#page-paymentPassword');
                    });
                });
            },
            function () {
            }
        );
    });
    var exchange = function (type,val,s_phone) {

        jomooAjax({//验证支付密码
            "apiLast": 'validate/validatePassword',
            "params": {password:val},
            "success": function (data) {
                if (data.status){
                    exchange_CH(type,val,s_phone);
                } else {
                    //$.toast(data.detail);
                    $.closeModal(".modal");
                    $.alert(data.detail, '', function () {
                        //$.router.back();
                        $("#pwd-input").val("");
                        $(".fake-box-input").val("");
                    });

                }
            }
        });
    };

    var exchange_CH = function (type,val,s_phone) {
        s_phone = $.trim(s_phone);
        console.dir(s_phone);
        jomooAjax({//验证支付密码
            "apiLast": 'exchange/exchange',
            "params": {"type": type, "gift": gift, "worth": worth, "score":score, "phone": s_phone},
            "success": function (data) {
                if (data.status){
                    $.closeModal(".modal");
                    $.alert(data.detail, '', function () {
                        $.router.back();
                    });
                } else {
                    $.closeModal(".modal");
                    //$.toast(data.errorMessage);
                    $.alert(data.errorMessage, '', function () {

                    });
                }
            }
        });
    };

    /*输入支付密码弹窗关闭事件*/
    $(".close").live("click", function () {
        $.closeModal(".modal");
    });
});
});